#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arghandler.h"

ArgHandler::ArgHandler ( int argcParameter, char *argvParameter[] )
{
    std::string temp;
    for (int i=0; i<argcParameter; i++)
    {
        temp = argvParameter[i];
        argVector.push_back( temp );
    }
    argVector.erase ( argVector.begin() );

    std::vector<std::string>::iterator it;

    for ( it=argVector.begin(); it!=argVector.end(); it++ )
    {
        temp = *it;
        if ( (temp.at(0) != '-') || (temp.size()<2) )
            break;
        temp.erase(0, 1);
        char c = temp.at(0);
        temp.erase(0, 1);
        argMap.insert ( std::make_pair ( c, temp ) );
    }
    if ( argVector.begin() != it )
    {
        argVector.erase ( argVector.begin(), it );
    }
}

bool ArgHandler::argIsSet(char c)
{
    return argMap.count(c);
}

int ArgHandler::getArgMapInt(char c)
{
    std::string temp = getArgMapString(c);
    return atoi( temp.c_str() );
}

std::string ArgHandler::getArgMapString(char c)
{
    if ( !argIsSet ( c ) )
        return "";

    return argMap[c];
}

void ArgHandler::getArgMapIntVector(char c, std::vector<size_t>& v)
{
    char delims[] = ",.#";
    char * temp = strtok ( (char *) getArgMapString(c).c_str(), delims );
    while (temp != NULL)
    {
        v.push_back( (size_t) abs ( atoi( ( temp ) ) ) );
        temp = strtok (NULL, delims);
    }
}

void ArgHandler::getArgVectorRemaining(std::vector<std::string>& v)
{
    v = argVector;
}
