#include <wx/mediactrl.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
#include "looptimer.h"
#include "smasherMain.h"

LoopTimer::LoopTimer(
    wxFrame *frameParameter,
    wxMediaCtrl *mediaCtrlParameter,
    wxMediaCtrl *mediaCtrlParameterAltParameter,
    bool *loopStateParameter ) :
        frame ( frameParameter ),
        mediaCtrl ( mediaCtrlParameter ),
        mediaCtrlAlt ( mediaCtrlParameterAltParameter ),
        loopState ( loopStateParameter )
{
}

void LoopTimer::Notify()
{
    if ( ! ( *loopState ) )
    {
        return;
    }

    smasherFrame *sf = ( smasherFrame *)frame;
    sf->swapMediaCtrls();
    sf->getCurrentMediaCtrl()->Play();
    sf->getAlternativeMediaCtrl()->Pause();
    sf->getAlternativeMediaCtrl()->Seek( 0 );

    sf->startLoopTimer();
}

