#include <ctime>
#include <iostream>
#include <fstream>
#include <memory>
#include <stdexcept>

#include <wx/aui/aui.h>
#include <wx/aboutdlg.h>
#include <wx/fileconf.h>
#include <wx/frame.h>
#include <wx/generic/aboutdlgg.h>
#include <wx/grid.h>
#include <wx/tglbtn.h>

#include <wx/menu.h>
#include <wx/sizer.h>
#include <wx/sound.h>
#include <wx/spinctrl.h>
#include <wx/stdpaths.h>
#include <wx/textctrl.h>
#include <wx/treebook.h>
#include <wx/utils.h>
#include <wx/timer.h>
#include <wx/valtext.h>

#include "appicon.h"
#include "binaryfile.h"
#include "chaingrid.h"
#include "effectsgrid.h"
#include "monochromegrid.h"
#include "keymapper.h"
#include "mediatimer.h"
#include "looptimer.h"
#include "samplemath.h"
#include "settingsbook.h"
#include "slicebitcrushtransformer.h"
#include "slicecompresstransformer.h"
#include "slicedelaytransformer.h"
#include "slicedelayphasetransformer.h"
#include "slicedelayvariabletransformer.h"
#include "slicedistorttransformer.h"
#include "slicedownsampletransformer.h"
#include "slicefadetransformer.h"
#include "sliceffttransformer.h"
#include "slicefftwindowedtransformer.h"
#include "slicegatetransformer.h"
#include "slicenormalizetransformer.h"
#include "slicepitchtransformer.h"
#include "sliceretriggertransformer.h"
#include "slicereversetransformer.h"
#include "slicetremolotransformer.h"
#include "slicetapestoptransformer.h"
#include "slicedelayphasetransformer.h"
#include "smashercopy.h"
#include "smashgridmapper.h"
#include "smashercriticalsectionlocker.h"
#include "smasherMain.h"
#include "smashthread.h"
#include "wav16smash.h"
#include "wavewindow.h"
#include "wraptempfilename.h"
#ifndef __WXMSW__
#include "wraplibmad.h"
#endif

//#define SMASHER_DEBUG

BEGIN_EVENT_TABLE(smasherFrame, wxFrame)
    EVT_MEDIA_STATECHANGED(ID_MEDIACTRL, smasherFrame::OnMediaStateChanged)
    EVT_MEDIA_STATECHANGED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaStateChanged)
    EVT_MEDIA_FINISHED(ID_MEDIACTRL, smasherFrame::OnMediaFinished)
    EVT_MEDIA_FINISHED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaFinished)
    EVT_MEDIA_LOADED(ID_MEDIACTRL, smasherFrame::OnMediaLoaded)
    EVT_MEDIA_LOADED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaLoaded)
    EVT_TIMER(ID_TIMER, smasherFrame::OnTimer)
    EVT_MENU(ID_LOOP, smasherFrame::OnLoop)
    EVT_CLOSE(smasherFrame::OnClose)
    EVT_IDLE(smasherFrame::OnIdle)
    EVT_MENU(ID_FX_ORDER_CLEAR, smasherFrame::OnFxOrderClear)
    EVT_MENU(ID_FX_ORDER_SHUFFLE_ALL, smasherFrame::OnFxOrderShuffleAll)
    EVT_MENU(ID_FX_ORDER_SHUFFLE_BY_KEY, smasherFrame::OnFxOrderShuffleByKey)
    EVT_MENU(ID_FX_ORDER_STICKY, smasherFrame::OnFxOrderSticky)
    EVT_MENU(ID_PAUSE, smasherFrame::OnPause)
    EVT_MENU(ID_PLAY, smasherFrame::OnPlay)
    EVT_MENU(ID_PLAY_SMASHED, smasherFrame::OnPlaySmashed)
    EVT_MENU(ID_SHOW_EFFECTS, smasherFrame::OnShowEffects)
    EVT_MENU(ID_SHOW_LOG, smasherFrame::OnShowLog)
    EVT_MENU(ID_SHOW_PLOT, smasherFrame::OnShowPlot)
    EVT_MENU(ID_SHOW_SETTINGS, smasherFrame::OnShowSettings)
    EVT_MENU(ID_SHOW_TRANSPORT_ONLY, smasherFrame::OnShowTransportOnly)
    EVT_MENU(ID_SLICE_ORDER_1_TO_N, smasherFrame::OnSliceOrder1ToN)
    EVT_MENU(ID_SLICE_ORDER_CLEAR, smasherFrame::OnSliceOrderClear)
    EVT_MENU(ID_SLICE_ORDER_N_TO_1, smasherFrame::OnSliceOrderNTo1)
    EVT_MENU(ID_SLICE_ORDER_SHUFFLE_ALL, smasherFrame::OnSliceOrderShuffleAll)
    EVT_MENU(ID_SLICE_ORDER_ROTATE_LEFT, smasherFrame::OnSliceOrderRotateLeft)
    EVT_MENU(ID_SLICE_ORDER_ROTATE_RIGHT, smasherFrame::OnSliceOrderRotateRight)
    EVT_MENU(ID_SLICE_ORDER_SHUFFLE_BY_KEY, smasherFrame::OnSliceOrderShuffleByKey)
    EVT_MENU(wxID_ABOUT, smasherFrame::OnAbout)
    EVT_MENU(wxID_EXIT, smasherFrame::OnQuit)
    EVT_MENU(ID_LOAD_MACHINE_STATE, smasherFrame::OnLoadMachineState)
    EVT_MENU(ID_SAVE_MACHINE_STATE, smasherFrame::OnSaveMachineState)
    EVT_MENU(ID_OPEN, smasherFrame::OnOpen)
    EVT_MENU(ID_SAVE, smasherFrame::OnSave)
    EVT_MENU(wxID_UNDO, smasherFrame::OnUndo)
    EVT_MENU(wxID_REDO, smasherFrame::OnRedo)
    EVT_MENU(ID_STOP, smasherFrame::OnStop)
    EVT_MENU(ID_RESTORE_DEFAULT, smasherFrame::OnRestoreDefault)
    EVT_MENU(ID_TOGGLE_PLAY, smasherFrame::OnTogglePlay)
    EVT_UPDATE_UI(wxID_REDO, smasherFrame::OnUpdateRedo )
    EVT_UPDATE_UI(wxID_UNDO, smasherFrame::OnUpdateUndo )
    EVT_UPDATE_UI_RANGE( ID_OPEN, ID_PLAY_SMASHED, smasherFrame::OnUpdateThreadRunning )
    EVT_UPDATE_UI_RANGE( ID_SHOW_EFFECTS, ID_SHOW_SETTINGS, smasherFrame::OnUpdatePaneMaximized )
    EVT_SPINCTRL(ID_SLICE_NO_CHANGE, smasherFrame::OnSliceNoChange )
    EVT_KEY_DOWN( smasherFrame::OnKeyDown )
    #ifndef __WXMSW__
    EVT_COMMAND_SCROLL( ID_VOLUME_SLIDER, smasherFrame::OnVolumeChanged )
    #else
    EVT_SPINCTRL( ID_VOLUME_SLIDER, smasherFrame::OnVolumeChanged )
    #endif
    EVT_TREEBOOK_PAGE_CHANGED(ID_SETTINGS_CHANGED, smasherFrame::OnSettingsChanged)
    EVT_GRID_LABEL_LEFT_CLICK( smasherFrame::OnGridColLeftClick )
    #ifdef __WXMSW__
    EVT_DROP_FILES ( smasherFrame::OnDropFiles )
    #endif
END_EVENT_TABLE()

smasherFrame::smasherFrame( wxFrame *frame, const wxString& title ) :
        wxFrame(frame, -1, title, wxPoint (-1, -1), wxSize ( 1024, 768 )),
        config ( NULL ), thread ( NULL ),
        smashRequired ( false ), threadAbort ( false ), pathValid ( true ),
        alternativeCtrlIsCurrentCtrl ( false ), isPlaySmashedButton ( true ),
        closeDown ( false ), threadState ( SMASH_THREAD_INIT ), gridColumnMemory ( -1 )
{

    csRefCounter = 0;

    config = new wxFileConfig (
#ifdef __WXMSW__
        _T( ".smasher" )
#else
        _T( "smasher" )
#endif
    );

#ifdef __WXMSW__
    DragAcceptFiles( true );
#endif

#ifndef __WXMSW__
    SetFont ( *wxSMALL_FONT );
#endif

    wxString appPath = wxStandardPaths::Get().GetExecutablePath();
    wxString drive, directory;
    wxFileName::SplitPath ( appPath, &drive, &directory, NULL, NULL );
    appDir =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory +
#ifndef __WXMSW__
        wxFileName::GetPathSeparator() +
        _T("..") +
        wxFileName::GetPathSeparator() +
        _T("share") +
        wxFileName::GetPathSeparator() +
        _T("smasher") +
#endif
        wxFileName::GetPathSeparator();

    wxString amenPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Amen_Break.wav");
    wxString pianoPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Piano.wav");
    wxString tr808Path = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("TR-808.wav");
    wxString synthPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Synth.wav");
    wxString sinePath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Sine_Wave.wav");

    fileIn = amenPath;

    wxImage::AddHandler ( new wxPNGHandler );

    loopState = loopSmashedState = pauseState = false;
    viewLogState = viewPlotState = viewEffectsState = viewSettingsState =
                                       viewTransportOnlyState = orderStickyState = false;
    idleCounter = 0;

    fileMenu = new wxMenu(_T(""));
    fileMenu->Append(ID_OPEN, _("&open...\tCtrl+O"), _("open"));
    fileMenu->Append(ID_SAVE, _("&save as...\tCtrl+S"), _("save as"));
    fileMenu->Append(ID_LOAD_MACHINE_STATE, _("&load machine state..."), _("load machine state"));
    fileMenu->Append(ID_SAVE_MACHINE_STATE, _("s&ave machine state as..."), _("save machine state as"));
    fileMenu->Append(ID_RESTORE_DEFAULT, _("&restore default state\tCtrl+R"), _("default state"));
    fileMenu->Append(wxID_EXIT, _("&quit\tAlt-F4"), _("quit"));
    editMenu = new wxMenu(_T(""));
    editMenu->Append ( wxID_UNDO, _("&undo\tCtrl+Z"), _("undo") );
    editMenu->Append ( wxID_REDO, _("&redo\tCtrl+Y"), _("redo") );

    transportMenu = new wxMenu(_T(""));
    transportMenu->Append(ID_PLAY, _("&play\tF2"), _("play"));
    transportMenu->Append(ID_PLAY_SMASHED, _("&play smashed\tF3"), _("play smashed"));
    transportMenu->AppendCheckItem(ID_PAUSE, _("&pause\tF4"), _("pause"));
    transportMenu->Append(ID_STOP, _("&stop\tF5"), _("stop"));
    transportMenu->Append(ID_TOGGLE_PLAY, _("&toggle play\tSPACE"), _("toggle play"));
    transportMenu->AppendCheckItem(ID_LOOP, _("&loop\tF6"), _("loop"));
    viewMenu = new wxMenu(_T(""));
    viewMenu->AppendCheckItem(ID_SHOW_EFFECTS,_("&effects\tF9"), _("effects"));
    viewMenu->AppendCheckItem(ID_SHOW_SETTINGS,_("&controls\tF10"), _("controls"));
#ifdef SMASHER_DEBUG
    viewMenu->AppendCheckItem(ID_SHOW_LOG,_("&log\tF11"), _("log"));
#endif
    viewMenu->AppendCheckItem(ID_SHOW_PLOT,_("&waveform\tF12"), _("waveform"));
    viewMenu->AppendCheckItem(ID_SHOW_TRANSPORT_ONLY,_("&transport only\tCtrl+T"), _("transport only"));
    helpMenu = new wxMenu(_T(""));
    helpMenu->Append(wxID_ABOUT, _("&about\tF1"), _("show info about this application"));

    wxMenuBar* mbar = new wxMenuBar();
    mbar->Append(fileMenu, _("&file"));
    mbar->Append(editMenu, _("&edit"));
    mbar->Append(transportMenu, _("&transport"));
    mbar->Append(viewMenu, _("&view"));
    mbar->Append(helpMenu, _("&help"));
    SetMenuBar(mbar);

    int fields = STATUS_END - STATUS_MAIN;
    wxStatusBar *status = CreateStatusBar( fields );
    int widthArray[5] = { -1, 85, 85, 85, 85 };
    status->SetStatusWidths ( fields, widthArray );

    size_t bitmapSize = 24;
    wxBitmap openIcon, saveIcon, pauseIcon, playIcon, stopIcon, loopIcon, playSmashedIcon, undoIcon, redoIcon,
    order1ToNIcon, orderNTo1Icon, orderRotateLeftIcon, orderRotateRightIcon, orderShuffleAllIcon, orderShuffleByKeyIcon,
    orderClearIcon, orderStickyIcon, settingsIcon, logIcon, plotIcon, effectsIcon, transportOnlyIcon;
    openIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_open.png" ), wxBITMAP_TYPE_PNG );
    saveIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("filesave_gs.png" ), wxBITMAP_TYPE_PNG );
    playIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_play.png" ), wxBITMAP_TYPE_PNG );
    pauseIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("media-playback-pause.png" ), wxBITMAP_TYPE_PNG );
    stopIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_stop.png" ), wxBITMAP_TYPE_PNG );
    loopIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_repeat.png" ), wxBITMAP_TYPE_PNG );
    playSmashedIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_play_inv.png" ), wxBITMAP_TYPE_PNG );
    undoIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-undo_gs.png" ), wxBITMAP_TYPE_PNG );
    redoIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-redo_gs.png" ), wxBITMAP_TYPE_PNG );
    order1ToNIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_draw-line.png" ), wxBITMAP_TYPE_PNG );
    orderNTo1Icon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_draw-line_r.png" ), wxBITMAP_TYPE_PNG );
    orderRotateLeftIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_data-previous.png" ), wxBITMAP_TYPE_PNG );
    orderRotateRightIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_data-next.png" ), wxBITMAP_TYPE_PNG );
    orderShuffleAllIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_shuffle.png" ), wxBITMAP_TYPE_PNG );
    orderShuffleByKeyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_id.png" ), wxBITMAP_TYPE_PNG );
    orderClearIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-clear-gs.png" ), wxBITMAP_TYPE_PNG );
    orderStickyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_hyperlink.png" ), wxBITMAP_TYPE_PNG );
    settingsIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("preferences-desktop.png" ), wxBITMAP_TYPE_PNG );
    effectsIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("system-run.png" ), wxBITMAP_TYPE_PNG );
    logIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("logviewer_gs.png" ), wxBITMAP_TYPE_PNG );
    plotIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_gamma.png" ), wxBITMAP_TYPE_PNG );
    transportOnlyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("window_nofullscreen_gs.png" ), wxBITMAP_TYPE_PNG );

    toolbar = new wxAuiToolBar ( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxAUI_TB_HORZ_TEXT );
#ifndef __WXMSW__
    volumeSlider = new wxSlider ( toolbar, ID_VOLUME_SLIDER, 10, 0, 10, wxDefaultPosition, wxSize ( 64, 24 ), wxSL_HORIZONTAL );
#else
    volumeSlider = new wxSpinCtrl (
        toolbar, ID_VOLUME_SLIDER, _(""), wxDefaultPosition,
        wxSize ( 48, 20 ), wxSP_ARROW_KEYS | wxSP_VERTICAL, 0, 10, 10, _("volume"));
#endif

    toolbar->SetToolBitmapSize(wxSize(bitmapSize,bitmapSize));
    toolbar->AddTool( ID_OPEN, _(""), openIcon, _("open") );
    toolbar->AddTool( ID_SAVE, _(""), saveIcon, _("save") );
    toolbar->AddTool( wxID_UNDO, _(""), undoIcon, _("undo") );
    toolbar->AddTool( wxID_REDO, _(""), redoIcon, _("redo") );
    toolbar->AddSeparator ( );
    toolbar->AddTool( ID_PLAY, _(""), playIcon, _("play original"), wxITEM_CHECK );
    toolbar->AddTool( ID_PLAY_SMASHED, _(""), playSmashedIcon, _("play smashed"), wxITEM_CHECK );
    toolbar->AddTool( ID_PAUSE, _(""), pauseIcon, _("pause"), wxITEM_CHECK );
    toolbar->AddTool( ID_STOP, _(""), stopIcon, _("stop") );
    toolbar->AddTool( ID_LOOP, _(""), loopIcon, _("loop"), wxITEM_CHECK );
    toolbar->AddLabel( wxID_ANY, _("volume"),
#ifdef __WXMSW__
                       32
#else
                       45
#endif
                     );
    toolbar->AddControl( volumeSlider, _("volume") );
    toolbar->AddTool( ID_SHOW_TRANSPORT_ONLY, _(""), transportOnlyIcon, _("transport only"), wxITEM_CHECK );
    toolbar->Realize();

    mapToolbar = new wxAuiToolBar ( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxAUI_TB_HORZ_TEXT );
    sliceNoMemory = 16;
    sliceNoSpinControl = new wxSpinCtrl (
        mapToolbar, ID_SLICE_NO_CHANGE, _(""), wxDefaultPosition, wxSize ( 48, 20 ),
        wxSP_ARROW_KEYS, 1, 64, sliceNoMemory, _("sliceNo"));

    mapToolbar->SetToolBitmapSize(wxSize(bitmapSize,bitmapSize));
    mapToolbar->AddTool( ID_SHOW_EFFECTS, _(""), effectsIcon, _("show/hide effects"), wxITEM_CHECK );
    mapToolbar->AddTool( ID_SHOW_PLOT, _(""), plotIcon, _("show/hide plot"), wxITEM_CHECK );
    mapToolbar->AddTool( ID_SHOW_SETTINGS, _(""), settingsIcon, _("show/hide settings"), wxITEM_CHECK );
#ifdef SMASHER_DEBUG
    mapToolbar->AddTool( ID_SHOW_LOG, _(""), logIcon, _("show/hide log"), wxITEM_CHECK );
#endif
    mapToolbar->AddSeparator();
    mapToolbar->AddLabel( wxID_ANY, _("slices"),
#ifdef __WXMSW__
                          25
#else
                          35
#endif
                        );
    mapToolbar->AddControl( sliceNoSpinControl, _("slices"));
    mapToolbar->AddTool( ID_SLICE_ORDER_1_TO_N, _(""), order1ToNIcon, _("original slice order") );
    mapToolbar->AddTool( ID_SLICE_ORDER_N_TO_1, _(""), orderNTo1Icon, _("invert slice order") );
    mapToolbar->AddTool( ID_SLICE_ORDER_ROTATE_LEFT, _(""), orderRotateLeftIcon, _("rotate left") );
    mapToolbar->AddTool( ID_SLICE_ORDER_ROTATE_RIGHT, _(""), orderRotateRightIcon, _("rotate right") );
    mapToolbar->AddTool( ID_SLICE_ORDER_SHUFFLE_ALL, _(""), orderShuffleAllIcon, _("shuffle all slices") );
    mapToolbar->AddTool( ID_SLICE_ORDER_SHUFFLE_BY_KEY, _(""), orderShuffleByKeyIcon, _("permute selected slices") );
    mapToolbar->AddTool( ID_SLICE_ORDER_CLEAR, _(""), orderClearIcon, _("clear pattern") );
    mapToolbar->AddSeparator();
    mapToolbar->AddTool( ID_FX_ORDER_SHUFFLE_ALL, _(""), orderShuffleAllIcon, _("shuffle all effects") );
    mapToolbar->AddTool( ID_FX_ORDER_SHUFFLE_BY_KEY, _(""), orderShuffleByKeyIcon, _("permute selected effects") );
    mapToolbar->AddTool( ID_FX_ORDER_CLEAR, _(""), orderClearIcon, _("clear effects") );
    mapToolbar->AddTool( ID_FX_ORDER_STICKY, _(""), orderStickyIcon, _("link effects to pattern"), wxITEM_CHECK );
    mapToolbar->Realize();

    size_t sliceNo = sliceNoSpinControl->GetValue();
    size_t cellHeight = 16;
    mapGrid = new MonochromeGrid ( this, wxID_ANY, sliceNo, sliceNo, cellHeight );
    mapGrid->autoLabel ( );

    effectsVector.push_back ( _("distort"));
    effectsVector.push_back ( _("bitcrush"));
    effectsVector.push_back ( _("downsample"));
    effectsVector.push_back ( _("retrigger"));
    effectsVector.push_back ( _("lowpass"));
    effectsVector.push_back ( _("highpass"));
    effectsVector.push_back ( _("bandpass"));
    effectsVector.push_back ( _("bandstop"));
    effectsVector.push_back ( _("master filter"));
    effectsVector.push_back ( _("tap delay"));
    effectsVector.push_back ( _("flanging"));
    effectsVector.push_back ( _("phasing"));
    effectsVector.push_back ( _("tremolo"));
    effectsVector.push_back ( _("fade in"));
    effectsVector.push_back ( _("fade out"));
    effectsVector.push_back ( _("tapestop"));
    effectsVector.push_back ( _("reverse"));

    effectsGrid = new EffectsGrid ( this, wxID_ANY, effectsVector, sliceNo, cellHeight );

#ifdef SMASHER_DEBUG
    logText = new wxTextCtrl( this, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE );
#endif

    redirect = new wxStreamToTextRedirector ( logText );

    timer = new wxTimer ( this, ID_TIMER );

    mediaCtrl = new wxMediaCtrl ( this, ID_MEDIACTRL
#ifdef __WXMSW__
                                  , wxEmptyString, wxDefaultPosition, wxDefaultSize, 0,
                                  wxMEDIABACKEND_WMP10//_T( "" )
#endif
                                );

    mediaTimer = new MediaTimer ( this );
    mediaTimer->SetOwner( this );
    if ( !mediaTimer->Start ( 10 ) )
        std::cout << "can't start timer" << std::endl;

    loopTimer = new LoopTimer ( this, mediaCtrl, mediaCtrlAlt, &loopState );
    loopTimer->SetOwner( this );

    timer->Start( 100 );

    mediaCtrlAlt = new wxMediaCtrl ( this, ID_MEDIACTRL_ALT
#ifdef __WXMSW__
                                     , wxEmptyString, wxDefaultPosition, wxDefaultSize, 0,
                                     wxMEDIABACKEND_WMP10
#endif
                                   );

    mediaTimerAlt = new MediaTimer ( this );
    mediaTimerAlt->SetOwner( this );
    if ( !mediaTimerAlt->Start ( 10 ) )
        std::cout << "can't start timer" << std::endl;

    wxSize plotSize = wxSize ( -1, 75 );
    wxSize previewBoxSize = wxSize ( ( int ) ( 1.1 * plotSize.GetWidth()), -1 );

    lPlot = new WaveWindow ( this, wxID_ANY, wxDefaultPosition, plotSize );
    rPlot = new WaveWindow ( this, wxID_ANY, wxDefaultPosition, plotSize );


    manager = new wxAuiManager ( this );

    wxSize bookSize =
#ifdef __WXMSW__
        wxSize ( ( effectsVector.size() * 17 ) + 10, -1);
#else
        wxSize ( ( effectsVector.size() * 17 ) + 10, -1);
#endif

    settingsBook = new SettingsBook ( this, wxID_ANY, effectsGrid, bookSize.x );


#ifdef __WXMSW__
    wxSize logSize = wxSize( -1, 50 );
    wxSize seqSize = wxSize( -1, cellHeight * ( sliceNo + 1 ) );
    wxSize fxSize = wxSize( -1, ( int ) ( 0.75 * cellHeight * effectsVector.size() ));
    wxSize wavSize = wxSize( -1, 75 );
#else
    wxSize logSize = wxSize( -1, -1 );
    wxSize seqSize = wxSize( -1, -1 );
    wxSize fxSize = wxSize( -1, -1 );
    wxSize wavSize = wxSize( -1, -1 );
#endif

    manager->AddPane (
        toolbar, wxAuiPaneInfo().
        Name(wxT("toolbar")).Caption(wxT("toolbar")).
        ToolbarPane().Top().
        Layer(3).
        Row(0).Position(0).
        Floatable ( false ).Gripper ( false ));

    manager->AddPane (
        mapToolbar, wxAuiPaneInfo().
        Name(wxT("mapToolbar")).Caption(wxT("mapToolbar")).
        ToolbarPane().Top().
        Layer(3).
        Row(0).Position(1).
        Floatable ( false ).Gripper ( false ));

    manager->AddPane (
        settingsBook, wxAuiPaneInfo().
        Name(wxT("settingsbook")).Caption( _("controls")).
        Left().
        Layer(2).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( bookSize ).
        Hide());

    manager->AddPane (
        mapGrid, wxAuiPaneInfo().
        Name(wxT("mapGrid")).Caption(wxT("pattern")).
        Center().
        Layer(0).
        Position(0).
        Row(0).
        CloseButton ( false ).MaximizeButton( true ).MinimizeButton(true).
        Resizable( true ).Floatable ( false ).
        MinSize( seqSize ));
    manager->GetPane ( mapGrid ).dock_proportion = 7;

    manager->AddPane (
        effectsGrid, wxAuiPaneInfo().
        Name(wxT("effectsGrid")).Caption(wxT("effects")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(1).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( fxSize ).
        Hide());
    manager->GetPane ( effectsGrid ).dock_proportion = 4;

    manager->AddPane (
        lPlot,
        wxAuiPaneInfo().
        Name(wxT("waveformL")).Caption(_("left channel")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(2).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable ( true ).Floatable ( false ).
        MinSize( wavSize ).
        Hide() );
    manager->GetPane ( lPlot ).dock_proportion = 2;

    manager->AddPane (
        rPlot,
        wxAuiPaneInfo().
        Name(wxT("waveformR")).Caption(_("right channel")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(3).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Floatable ( false ).Resizable ( true ).
        MinSize( wavSize ).
        Hide() );
    manager->GetPane ( rPlot ).dock_proportion = 2;

#ifdef SMASHER_DEBUG
    manager->AddPane (
        logText, wxAuiPaneInfo().Caption( _("log")).
        Name(wxT("logText")).
        Bottom().
        Layer(3).
        MaximizeButton( true ).MinimizeButton( true ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( logSize ).
        Hide());
#endif

    manager->AddPane (
        mediaCtrl, wxAuiPaneInfo().Caption( _("media control")).
        Name(wxT("mediaCtrl")).
        Bottom().
        Layer(4).
        MaximizeButton( true ).MinimizeButton( true ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( logSize )
        .Hide()
    );

    DoFxOrderSticky();

    defaultStates = new std::vector<wxString>;
    defaultStates->push_back (
        _T ( "fileIn=" ) +
        amenPath +
        SMASHER_PRESET_AMEN1 );
    defaultStates->push_back (
        _T ( "fileIn=" ) +
        pianoPath +
        SMASHER_PRESET_PIANO1  );
    defaultStates->push_back (
        _T ( "fileIn=" ) +
        tr808Path +
        SMASHER_PRESET_TR8081 );
    defaultStates->push_back (
        _T ( "fileIn=" ) +
        synthPath +
        SMASHER_PRESET_SYNTH1 );
    defaultStates->push_back (
        _T ( "fileIn=" ) +
        sinePath +
        SMASHER_PRESET_SINE1 );

    loadState ( defaultStates->at ( 0 ) );
    wxString defaultState = saveState();

    if ( config )
    {
        bool val = false;
        int intVal;
        wxString strVal;

        bool hasEntry;

        hasEntry = config->Read ( _T ("version"), &val );
        if ( !hasEntry || val < SMASHER_REQUIRED_CONFIG_VERSION )
        {
            SetStatusText ( _T("Configuration file out of date") );
        }

        hasEntry = config->Read ( _T ("showEffectsGrid"), &val );
        if ( !hasEntry || val )
            DoShowEffects();

        hasEntry = config->Read ( _T ("showPlot"), &val );
        if ( !hasEntry || val )
            DoShowPlot();

#ifdef SMASHER_DEBUG
        hasEntry = config->Read ( _T ("showLogText"), &val );
        if ( hasEntry && val )
            DoShowLog();
#endif

        hasEntry = config->Read ( _T ("showSettingsBook"), &val );
        if ( !hasEntry || val )
            DoShowSettings();

        hasEntry = config->Read ( _T ("showTransportOnly"), &val);
        if ( hasEntry && val )
            DoShowTransportOnly();

        int currentSettingsBookPage, currentTreePage;

        if ( config->Read ( _T("currentSettingsBookPage"), &intVal ))
        {
            currentSettingsBookPage = intVal;
            settingsBook->SetSelection ( currentSettingsBookPage );
            if ( intVal < 2 )
            {
                if ( config->Read ( _T("currentTreeBookPage" ), &intVal ))
                {
                    currentTreePage = intVal;
                    wxTreebook *tree = (wxTreebook *)settingsBook->GetPage ( currentSettingsBookPage );
                    tree->SetSelection ( currentTreePage );
                }
            }
        }

        if ( config->Read ( _T("playbackCompensation"), &intVal ) )
        {
            settingsBook->getPlaybackSlider()->SetValue ( intVal );
        }

        if ( config->Read ( _T("playbackCompensationChecked"), &val ) )
        {
            settingsBook->getPlaybackCheckbox()->SetValue ( val );
        }

        if ( config->Read ( _T("volume"), &intVal ) )
        {
            volumeSlider->SetValue ( intVal );
            mediaCtrl->SetVolume( intVal * 0.1 );
            mediaCtrlAlt->SetVolume( intVal * 0.1 );
        }


        if ( config->Read ( _T("hideFxRows"), &strVal ) )
        {
            std::string stdVal = ( const char * ) strVal.mb_str ( wxConvUTF8 );
            char delims[] = "|";
            char *temp = strtok ( ( char * ) stdVal.c_str(), delims );
            std::set<wxString> hiddenFxRows;
            while ( temp != NULL )
            {
                std::string currentLabel = temp;
                hiddenFxRows.insert ( wxString ( currentLabel.c_str(), wxConvUTF8, currentLabel.size() ) );
                temp = strtok ( NULL, delims );
            }
            int limit = ID_EFFECTS_START + effectsGrid->GetNumberRows();
            for ( int i = ID_EFFECTS_START; i < limit; i++ )
            {
                wxToggleButton *currentToggleButton = ( wxToggleButton* ) FindWindowById ( i, settingsBook );
                currentToggleButton->SetValue ( !hiddenFxRows.count ( currentToggleButton->GetLabel() ) );
            }
            settingsBook->updateShowFxRows();
        }
        /*else
        {
            effectsGrid->showRow ( _T("fade in"), false );
            effectsGrid->showRow ( _T("fade out"), false );
            effectsGrid->showRow ( _T("bandpass"), false );
            effectsGrid->showRow ( _T("bandstop"), false );
        }*/

        wxString state = config->Read ( _T ("state"), wxEmptyString );
        if ( !state.empty() )
            loadState ( state );
    }

    stateMemory = saveState();
    history.initialize ( stateMemory );

    settingsBook->initPlotAreas();

    loopLatency = ( settingsBook->getPlaybackCheckbox()->IsChecked() ) ? settingsBook->getPlaybackSlider()->GetValue() : 0;

    for ( size_t i = 0; i < 64; i++ )
        gridHighlightVector.push_back ( -1 );

    try
    {
        w = new Wav16Smash( &threadAbort, &smashMessage );
        pathValid =  DoOpen ( fileIn );
        if ( pathValid )
        {
            updateTitle ( fileIn );
        }

    }
    catch (std::exception &e)
    {
        std::cout << "smasherFrame c'tor: " << e.what() << std::endl;
    }
    manager->Update();

}

smasherFrame::~smasherFrame()
{
    DoStop();
    closeDown = true;
    mediaTimer->Stop();
    mediaTimerAlt->Stop();
    loopTimer->Stop();
    timer->Stop();

    waitForThreadsToFinish();

    if ( config )
    {
        config->Write ( _T("version"), SMASHER_VERSION );
        config->Write ( _T("showEffectsGrid"), viewMenu->IsChecked ( ID_SHOW_EFFECTS ) );
#ifdef SMASHER_DEBUG
        config->Write ( _T("showLogText"), viewMenu->IsChecked ( ID_SHOW_LOG ) );
#endif
        config->Write ( _T("showPlot"), viewMenu->IsChecked ( ID_SHOW_PLOT ) );
        config->Write ( _T("showSettingsBook"), viewMenu->IsChecked ( ID_SHOW_SETTINGS ) );
        config->Write ( _T("showTransportOnly"), viewMenu->IsChecked ( ID_SHOW_TRANSPORT_ONLY ) );

        int settingsBookSelection = settingsBook->GetSelection();
        int settingsTreeSelection = -1;
        if ( settingsBookSelection < 2 )
        {
            wxTreebook *bookSelection = ( wxTreebook *) ( settingsBook->GetPage( settingsBookSelection ));
            settingsTreeSelection = bookSelection->GetSelection();
        }
        config->Write ( _T("currentSettingsBookPage"), settingsBookSelection );
        config->Write ( _T("currentTreeBookPage"), settingsTreeSelection );
        config->Write ( _T("playbackCompensation"), settingsBook->getPlaybackSlider()->GetValue() );
        config->Write ( _T("playbackCompensationChecked"), settingsBook->getPlaybackCheckbox()->IsChecked() );
        config->Write ( _T("volume"), volumeSlider->GetValue() );

        wxString hideFxRowsState;
        int limit = ID_EFFECTS_START + effectsGrid->GetNumberRows();
        for ( int i = ID_EFFECTS_START; i < limit; i++ )
        {
            wxToggleButton *currentToggleButton = ( wxToggleButton* ) FindWindowById ( i, settingsBook );
            if ( !currentToggleButton->GetValue() )
            {
                hideFxRowsState += currentToggleButton->GetLabel();
                hideFxRowsState += _T("|");
            }
        }
        config->Write ( _T( "hideFxRows" ), hideFxRowsState );

        config->Write ( _T( "state" ), saveState() );
    }

    delete config;
    delete redirect;
    delete defaultStates;

    delete mediaCtrl;
    delete mediaCtrlAlt;

    delete mediaTimer;
    delete mediaTimerAlt;
    delete loopTimer;
    delete timer;
}

void smasherFrame::smashSync ()
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !pathValid )
        return;

    try
    {
        int wav16State = w->getState();
        if ( wav16State == WAV16_INIT || wav16State == WAV16_ERROR )
        {
            std::cout << "smashSync: wav16State == WAV16_INIT || wav16State == WAV16_ERROR" << std::endl;
            smashRequired = false;
            return;
        }

        w->clearSliceInfo();
        std::vector<size_t> posVector;
        mapGrid->getPositionVector( posVector );
        SmashGridMapper<std::vector<double> > sgm ( posVector );
        w->setSmashMapper ( &sgm );
        addTransformers( posVector );

        if ( !w->smash( mapGrid->GetNumberCols() ))
        {
            wxString wideMessage = wxString ( smashMessage.c_str(), wxConvUTF8, smashMessage.size() );
            SetStatusText ( wideMessage );
            return;
        }
    }
    catch (std::exception &e)
    {
        std::cout << "smashSync: " << e.what() << std::endl;
    }
}

void smasherFrame::smashAsync ()
{

    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    try
    {
        int wav16State = w->getState();
        if ( wav16State == WAV16_INIT || wav16State == WAV16_ERROR )
        {
            std::cout << "smashAsync: wav16State == WAV16_INIT || wav16State == WAV16_ERROR" << std::endl;
            smashRequired = false;
            return;
        }

        if ( !smashRequired )
        {
            return;
        }

        w->clearSliceInfo();
        std::vector<size_t> posVector;
        mapGrid->getPositionVector( posVector );

        SmashGridMapper<std::vector<double> > *sgm =
            new SmashGridMapper<std::vector<double> > ( posVector );

        w->setSmashMapper ( sgm );

        addTransformers( posVector );

        thread = new SmashThread (
            w,
            &threadState,
            &smashMessage,
            mapGrid->GetNumberCols() );

        if ( thread->Create() != wxTHREAD_NO_ERROR )
        {
            threadState = SMASH_THREAD_INIT;
            throw std::runtime_error ( "smasherFrame::smashAsync() - thread->Create() unsuccessful" );
            return;
        }

        threadState = SMASH_THREAD_RUNNING;
        smashRequired = false;
        threadAbort = false;

        thread->Run();
    }
    catch (std::exception &e)
    {
        std::cout << "smashAsync: " << e.what() << std::endl;
    }

}

void smasherFrame::DoClearOrder( MonochromeGrid *m )
{
    m->clearAll();
}

void smasherFrame::DoFxOrderShuffleAll ( )
{
    effectsGrid->clearAll();
    std::vector<size_t> positionVector;
    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 8 );
    effectsGrid->setNamedPositionVector ( _T("distort"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 12 );
    effectsGrid->setNamedPositionVector ( _T("bitcrush"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 12 );
    effectsGrid->setNamedPositionVector ( _T("downsample"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 12 );
    effectsGrid->setNamedPositionVector ( _T("tremolo"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 8 );
    effectsGrid->setNamedPositionVector ( _T("reverse"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 12 );
    effectsGrid->setNamedPositionVector ( _T("tapestop"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("fade in"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("fade out"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("lowpass"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("highpass"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("bandpass"), positionVector );

    effectsGrid->createRandomPositionVector ( positionVector, effectsGrid->GetNumberCols() / 16 );
    effectsGrid->setNamedPositionVector ( _T("bandstop"), positionVector );

}

void smasherFrame::DoFxOrderShuffleByKey (  )
{
    std::string key = (const char *) settingsBook->getKeyTextCtrl()->GetValue().mb_str ( wxConvUTF8 );
    if ( key.empty() )
        return;

    std::vector<wxString>::iterator it;
    std::vector<size_t> positionVector;
    std::vector<bool> binaryPositionVector;
    for ( it = effectsVector.begin(); it != effectsVector.end(); it++ )
    {
        positionVector.clear ();
        binaryPositionVector.clear();
        effectsGrid->getNamedPositionVector( *it, positionVector );
        int colNo = effectsGrid->GetNumberCols();
        bool found = false;
        for ( size_t i = 0; i < (size_t)colNo; i++ )
        {
            found = false;
            for ( size_t j = 0; j < positionVector.size(); j++ )
            {
                if ( i == positionVector.at ( j ) )
                {
                    found = true;
                    break;
                }
            }
            binaryPositionVector.push_back ( found );
        }
        KeyMapper<char, bool> *km = new KeyMapper<char, bool>( key, binaryPositionVector );
        km->map( binaryPositionVector );
        positionVector.clear();
        for ( size_t i = 0; i < binaryPositionVector.size(); i++ )
        {
            if ( binaryPositionVector.at ( i ) )
                positionVector.push_back ( i );
        }
        effectsGrid->setNamedPositionVector ( *it, positionVector );
    }
}

void smasherFrame::DoFxOrderSticky()
{
    orderStickyState = !orderStickyState;

    mapToolbar->EnableTool ( ID_FX_ORDER_CLEAR, !orderStickyState );
    mapToolbar->EnableTool ( ID_FX_ORDER_SHUFFLE_ALL, !orderStickyState );
    mapToolbar->EnableTool ( ID_FX_ORDER_SHUFFLE_BY_KEY, !orderStickyState );

    mapToolbar->ToggleTool ( ID_FX_ORDER_STICKY, orderStickyState );
    mapToolbar->Realize();
    manager->Update ();
}


void smasherFrame::DoIdle()
{
    int sliceNo = sliceNoSpinControl->GetValue( );
    if ( sliceNo != sliceNoMemory
            && sliceNo != mapGrid->GetNumberCols() )
    {
        DoSliceNoChange();
    }


    if ( !pathValid )
        return;

    if ( wxGetMouseState().LeftDown() )
        return;

    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( threadState == SMASH_THREAD_FINISHED )
    {
        wxString wideMessage = wxString ( smashMessage.c_str(), wxConvUTF8, smashMessage.size() );
        SetStatusText ( wideMessage );

        updatePlotArea();

        threadState = SMASH_THREAD_INIT;
        smashMessage.clear();

        return;
    }

    wxString state = saveState();

    if ( ( state == stateMemory ) && !smashRequired )
        return;

    SetStatusText ( wxEmptyString );

    history.pushState ( state );
    stateMemory = state;
    smashRequired = true;

    if ( threadState == SMASH_THREAD_RUNNING )
    {
        threadAbort = true;
        return;
    }

    smashAsync();

}

void smasherFrame::DoLoop ()
{
    loopState = !loopState;
    toolbar->ToggleTool (ID_LOOP, loopState);
    toolbar->Realize();
    transportMenu->Check (ID_LOOP, loopState);
}

void smasherFrame::DoPause()
{
    pauseState = !pauseState;
    toolbar->ToggleTool ( ID_PAUSE, pauseState );
    toolbar->Realize();
    transportMenu->Check (ID_PAUSE, pauseState );

    if ( pauseState && getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PLAYING )
    {
        getCurrentMediaCtrl()->Pause();
        loopTimer->Stop();
    }
    else if ( !pauseState && getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PAUSED )
    {
        getCurrentMediaCtrl()->Play();
        wxLongLong llTell = getCurrentMediaCtrl()->Tell();
        wxLongLong llLength = getCurrentMediaCtrl()->Length();
        loopTimer->Start ( (int) ( llLength.GetValue() - llTell.GetValue() ) - loopLatency, true );
    }
}

void smasherFrame::waitForThreadsToFinish ()
{
    size_t timeout = 10;
    while ( timeout )
    {
        {
            smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );
            if ( threadState != SMASH_THREAD_RUNNING )
                return;
        }
        ::wxMilliSleep ( 1000 );
        timeout--;
    }
    SetStatusText ( _("timed out") );
}

void smasherFrame::DoMediaFinished()
{}

void smasherFrame::DoMediaLoaded()
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !getCurrentMediaCtrl()->Play() )
    {
        std::cout << "DoMediaLoaded: !mediaCtrl->Play() - ID = " << getCurrentMediaCtrl()->GetId() << std::endl;
        return;
    }
    startLoopTimer();
}


bool smasherFrame::DoOpen( const wxString& wideFile )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    waitForThreadsToFinish ();

    SetStatusText ( wxEmptyString );

    if ( !wxFileName::FileExists ( wideFile ) )
    {
        wxString message = wideFile;
        message += _( " doesn't exist" );
        SetStatusText ( message );
        return false;
    }

    try
    {
        w->clear();

        std::string file = (const char *) wideFile.mb_str( wxConvUTF8);
        handleMp3 ( file );
        if ( !w->read ( ( char * ) file.c_str() ) )
        {
            SetStatusText ( _T ("can't read ") + wideFile );
            return false;
        }

        smashSync();

    }
    catch (std::exception &e)
    {
        std::cout << "DoOpen: " << e.what() << std::endl;
        return false;
    }

    wxString channelsInfo, samplerateInfo;
    channelsInfo = ( w->getChannels() == 2 ) ? _("stereo") : _("mono");
    samplerateInfo.Printf ( _("%i Hz"), w->getSamplerate() );

    if ( GetStatusBar()->GetStatusText ( STATUS_CHANNELS ) != channelsInfo )
        GetStatusBar()->SetStatusText ( channelsInfo, STATUS_CHANNELS );

    if ( GetStatusBar()->GetStatusText ( STATUS_SAMPLERATE ) != samplerateInfo )
        GetStatusBar()->SetStatusText ( samplerateInfo, STATUS_SAMPLERATE );

    wxString state = saveState();
    history.initialize( state );
    stateMemory = state;

    updatePlotArea();
    return true;
}


bool smasherFrame::DoPlaySmashed ( int requestedSlice )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    waitForThreadsToFinish();

    try {
        wxString tmpState = saveState();

        if ( smashedFileMap.count( tmpState ) )
        {
            /* bool loopIsToggled = ŃToolToggled( ID_LOOP ); */
            if ( !play ( smashedFileMap[tmpState] /*, loopIsToggled*/ ))
            {
                std::cout << "DoPlaySmashed: !play ( smashedFileMap[tmpState], loopIsToggled )" << std::endl;
                throw std::runtime_error ( "play() failed" );
            }
            return true;
        }
        if ( w->getState() == WAV16_HAS_DATA_IN )
        {
            smashSync();
            updatePlotArea();
        }

        if ( w->getState() != WAV16_HAS_DATA_OUT )
        {
            std::cout << "DoPlaySmashed: w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
            return false;
        }

        std::string fileOut;
        wxString wideFileOut;

        WrapTempFileName wtfn;
        wtfn.setKeepFiles ( true );
        fileOut = wtfn.name();
        wideFileOut = wtfn.wideName();

        wideFileOut += _T(".wav");
        fileOut += ".wav";

        tempFiles.push_back ( wideFileOut );

        if ( !w->write ( ( char * ) fileOut.c_str() ))
        {
            std::cout << "DoPlaySmashed: !w->write" << std::endl;
            throw std::runtime_error ( "write() failed" );
        }

        /* bool loopIsToggled = toolbar->GetToolToggled( ID_LOOP ); */
        if ( !play ( wideFileOut /*, loopIsToggled */ ))
        {
            std::cout << "DoPlaySmashed: !play ( wideFileOut, loopIsToggled ) )" << std::endl;
            throw std::runtime_error ( "play() failed" );
        }

        smashedFileMap.insert ( std::make_pair ( tmpState, wideFileOut ));
        return true;
    }
    catch (std::exception &e)
    {
        std::cout << "DoPlaySmashed: " << e.what() << std::endl;
        return false;
    }
}


void smasherFrame::DoShowEffects ( )
{
    viewEffectsState =  !viewEffectsState;
    mapToolbar->ToggleTool (ID_SHOW_EFFECTS, viewEffectsState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_EFFECTS, viewEffectsState );

    manager->GetPane ( effectsGrid ).Show( viewEffectsState );
    manager->Update ();
}

void smasherFrame::DoShowLog ()
{
#ifdef SMASHER_DEBUG
    viewLogState =  !viewLogState;
    mapToolbar->ToggleTool (ID_SHOW_LOG, viewLogState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_LOG, viewLogState );
    manager->GetPane ( logText ).Show( viewLogState );
    manager->Update ();
#endif
}

void smasherFrame::DoShowPlot ()
{
    viewPlotState =  !viewPlotState;
    mapToolbar->ToggleTool (ID_SHOW_PLOT, viewPlotState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_PLOT, viewPlotState );
    manager->GetPane ( lPlot ).Show ( viewPlotState );
    manager->GetPane ( rPlot ).Show ( viewPlotState );
    manager->Update ();
}

void smasherFrame::DoShowSettings ()
{
    viewSettingsState =  !viewSettingsState;
    mapToolbar->ToggleTool (ID_SHOW_SETTINGS, viewSettingsState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_SETTINGS, viewSettingsState );
    manager->GetPane ( settingsBook ).Show( viewSettingsState );
    manager->Update ();
}

void smasherFrame::DoShowTransportOnly ()
{
    viewTransportOnlyState =  !viewTransportOnlyState;
    if ( viewTransportOnlyState )
    {
        perspectiveMemory = manager->SavePerspective();
        sizeMemory = GetSize();
    }
    else if ( !perspectiveMemory.empty() )
    {
        manager->LoadPerspective( perspectiveMemory );
        SetSize ( sizeMemory );
        toolbar->ToggleTool (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
        toolbar->Realize();
        viewMenu->Check (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
        manager->Update();
        return;
    }
    toolbar->ToggleTool (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
    toolbar->Realize();
    viewMenu->Check (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
    manager->GetPane ( mapToolbar ).Show( !viewTransportOnlyState );
    manager->GetPane ( mapToolbar ).Show( !viewTransportOnlyState );
#ifdef SMASHER_DEBUG
    manager->GetPane ( logText ).Show( !viewTransportOnlyState );
#endif
    manager->GetPane ( settingsBook ).Show( !viewTransportOnlyState );
    manager->GetPane ( effectsGrid ).Show( !viewTransportOnlyState );
    manager->GetPane ( mapGrid ).Show( !viewTransportOnlyState );
    manager->GetPane ( lPlot ).Show( !viewTransportOnlyState );
    manager->GetPane ( rPlot ).Show( !viewTransportOnlyState );
    manager->Update ();
    Fit();
}

void smasherFrame::DoSliceNoChange ()
{
    int sliceNo = sliceNoSpinControl->GetValue( );
    if ( sliceNo != mapGrid->GetNumberCols() )
    {
        mapToolbar->Realize();

        mapGrid->resizeCols ( sliceNo );
        mapGrid->resizeRows ( sliceNo );
        mapGrid->autoLabel ( );
        effectsGrid->resizeCols ( sliceNo );
        sliceNoMemory = sliceNo;
    }
}

void smasherFrame::DoSliceOrder1ToN ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( i );

    m->setPositionVector ( positionVector );
}

void smasherFrame::DoSliceOrderNTo1 ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( colNo - i - 1 );

    m->setPositionVector ( positionVector );
}

void smasherFrame::DoSliceOrderShuffleAll ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( i );

    std::random_shuffle ( positionVector.begin(), positionVector.end() );
    m->setPositionVector ( positionVector );

    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        DoFxOrderShuffleAll();
}

void smasherFrame::DoSliceOrderShuffleByKey ( MonochromeGrid *m )
{
    std::string key = (const char *) settingsBook->getKeyTextCtrl()->GetValue().mb_str ( wxConvUTF8 );
    if ( key.empty() )
        return;
    std::vector<size_t> positionVector;
    m->getPositionVector( positionVector );
    KeyMapper<char, size_t> *km = new KeyMapper<char, size_t>( key, positionVector );

    km->map( positionVector );
    m->setPositionVector ( positionVector );

    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        DoFxOrderShuffleByKey();
}


void smasherFrame::DoStop ()
{
    getCurrentMediaCtrl()->Pause();
    getCurrentMediaCtrl()->Stop();
    getAlternativeMediaCtrl()->Pause();
    getAlternativeMediaCtrl()->Stop();
    loopTimer->Stop();
    if ( pauseState )
        DoPause();

    //wxSound::Stop();
}

void smasherFrame::DoVolumeChanged( )
{
    int selectedVolume = volumeSlider->GetValue();
    getCurrentMediaCtrl()->SetVolume( selectedVolume * 0.1 );
    getAlternativeMediaCtrl()->SetVolume( selectedVolume * 0.1 );
}

std::vector<wxString> *smasherFrame::getDefaultStates()
{
    return defaultStates;
}

void smasherFrame::handleMp3 ( std::string& file )
{
    if ( file.find(".mp3") == std::string::npos )
        return;

    wxString wideFile, wideFileOut;

    wideFile = wxString ( file.c_str(), wxConvUTF8, file.size() );
    std::string fileOut;
    WrapTempFileName wtfn;
    wtfn.setKeepFiles ( true );
    fileOut = wtfn.name();
    wideFileOut = wtfn.wideName();
    tempFiles.push_back ( wideFileOut );

#ifdef __WXMSW__
    wxString cmd = _T("\"");
    cmd += appDir;
    cmd += _T("bin");
    cmd += wxFileName::GetPathSeparator();
    cmd += _T("madplay.exe\" -o wave:");

    cmd += wideFileOut;
    cmd += _T(" ");
    cmd += _T("\"");
    cmd += wideFile;
    cmd += _T("\"");

    wxArrayString output;
    wxArrayString errors;
    if ( wxExecute ( cmd, output, errors, wxEXEC_SYNC ))
    {
        SetStatusText ( _T ( "mp3 to wav conversion failed" ) );
        return;
    }

    file =  (const char *) wideFileOut.mb_str( wxConvUTF8);
#else
    WrapLibMad wlm;
    if ( !wlm.mp3ToWav ( file, fileOut ) )
    {
        SetStatusText ( _T ( "mp3 to wav conversion failed" ) );
        return;
    }
    file = fileOut;
#endif
}

void smasherFrame::loadState ( const wxString& state, bool newData )
{
    if ( state.empty() )
        return;

    std::string stdState = (const char*) state.mb_str(wxConvUTF8);
    char delims[] = "|=";
    char * temp = strtok ( (char *) stdState.c_str(), delims );
    std::vector<std::string> v;
    while (temp != NULL)
    {
        v.push_back( temp );
        temp = strtok (NULL, delims);
    }
    std::map<wxString, wxString> m;
    if ( v.size() % 2 )
        return;

    std::string key, value;
    for ( size_t i = 0; i < v.size(); i +=2)
    {
        key = v.at ( i );
        value = v.at ( i + 1 );
        m.insert (
            std::make_pair (
                wxString ( key.c_str(), wxConvUTF8, key.size() ),
                wxString ( value.c_str(), wxConvUTF8, value.size() )));
    }

    mapGrid->clearAll();
    effectsGrid->clearAll();

    fileIn = m [ _T("fileIn") ];
    updateTitle ( fileIn );

    long intValue;
    m [ _T("sliceNo") ].ToLong ( &intValue );
    sliceNoSpinControl->SetValue ( intValue );
    mapGrid->resizeCols ( intValue );
    mapGrid->resizeRows ( intValue );
    effectsGrid->resizeCols ( intValue );
    mapGrid->loadState( m [ _T("mapGrid") ] );
    mapGrid->autoLabel();

    wxString name, posVectorString;
    std::vector<size_t> positionVector;
    size_t posVectorStringSize;
    size_t effectsVectorSize = effectsVector.size();
    wxString letter;
    for ( size_t i = 0; i < effectsVectorSize; i++ )
    {
        name = effectsVector.at ( i );

        if ( m.count( name ) )
        {
            posVectorString = m [ name ];
            posVectorStringSize = posVectorString.size();
            for ( size_t j = 0; j < posVectorStringSize; j++)
            {
                letter = posVectorString.substr ( j, 1 );
                if ( letter == _T ( "1" ) )
                    positionVector.push_back ( j );
            }
            effectsGrid->setNamedPositionVector ( name, positionVector );
            positionVector.clear();
        }
    }

    m [ _T("fadeInType") ] .ToLong ( &intValue );
    settingsBook->getFadeInTypesBox()->SetSelection( intValue );
    m [ _T("fadeOutType") ].ToLong ( &intValue );
    settingsBook->getFadeOutTypesBox()->SetSelection( intValue );
    m [ _T("tremoloType") ].ToLong ( &intValue );
    settingsBook->getTremoloTypesBox()->SetSelection( intValue );
    if ( m.count(_T("tremoloStereoMode")) )
    {
        m [ _T("tremoloStereoMode") ].ToLong ( &intValue );
        settingsBook->getTremoloStereoModeBox()->SetSelection( intValue );
    }
    m [ _T("bitCrushType") ].ToLong ( &intValue );
    settingsBook->getBitCrushTypesBox()->SetSelection( intValue );
    m [ _T("downSampleType") ].ToLong ( &intValue );
    settingsBook->getDownSampleTypesBox()->SetSelection( intValue );
    m [ _T("tremoloDepth") ].ToLong ( &intValue );
    settingsBook->getTremoloDepthSlider()->SetValue( intValue );
    m [ _T("tremoloPeriodsPerSlice") ].ToLong ( &intValue );
    settingsBook->getTremoloPeriodsPerSliceSlider()->SetValue( intValue );
    m [ _T("distortCutoff") ].ToLong ( &intValue );
    settingsBook->getDistortCutoffSlider()->SetValue( intValue );
    m [ _T("distortRange") ].ToLong ( &intValue );
    settingsBook->getDistortRangeSlider()->SetValue( intValue );
    m [ _T("distortAmplificationFactor") ].ToLong ( &intValue );
    settingsBook->getDistortAmplificationFactorSlider ()->SetValue( intValue );
    m [ _T("fadeOutRange") ].ToLong ( &intValue );
    settingsBook->getFadeOutRangeSlider()->SetValue( intValue );
    m [ _T("fadeInRange") ].ToLong ( &intValue );
    settingsBook->getFadeInRangeSlider()->SetValue( intValue );
    m [ _T("pitchSemitones") ].ToLong ( &intValue );
    settingsBook->getPitchSemitonesSlider()->SetValue( intValue );
    if ( m.count(_T("pitchAdjust")) )
    {
        m [ _T("pitchAdjust") ].ToLong ( &intValue );
        settingsBook->getPitchAdjustCheckbox()->SetValue( intValue );
    }
    settingsBook->getKeyTextCtrl()->SetValue( m [ _T("shuffleKey") ] );
    if ( m.count(_T("normalizeTo")) )
    {
        m [ _T("normalizeTo") ].ToLong ( &intValue );
        settingsBook->getNormalizeSlider()->SetValue( intValue );
    }
    if ( m.count(_T("normalize")) )
    {
        m [ _T("normalize") ].ToLong ( &intValue );
        settingsBook->getNormalizeCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("compressCutoff")) )
    {
        m [ _T("compressCutoff") ].ToLong ( &intValue );
        settingsBook->getCompressCutoffSlider()->SetValue( intValue );
    }
    if ( m.count(_T("compressRange")) )
    {
        m [ _T("compressRange") ].ToLong ( &intValue );
        settingsBook->getCompressRangeSlider()->SetValue( intValue );
    }
    if ( m.count(_T("compress")) )
    {
        m [ _T("compress") ].ToLong ( &intValue );
        settingsBook->getCompressCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("gate")) )
    {
        m [ _T("gate") ].ToLong ( &intValue );
        settingsBook->getGateCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("LPBandHi")) )
    {
        m [ _T("LPBandHi") ].ToLong ( &intValue );
        settingsBook->getFftLowPassBandHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("LPSlopeHi")) )
    {
        m [ _T("LPSlopeHi") ].ToLong ( &intValue );
        settingsBook->getFftLowPassSlopeHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("HPBandLo")) )
    {
        m [ _T("HPBandLo") ].ToLong ( &intValue );
        settingsBook->getFftHighPassBandLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("HPSlopeLo")) )
    {
        m [ _T("HPSlopeLo") ].ToLong ( &intValue );
        settingsBook->getFftHighPassSlopeLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BPBandLo")) )
    {
        m [ _T("BPBandLo") ].ToLong ( &intValue );
        settingsBook->getFftBandPassBandLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BPSlopeLo")) )
    {
        m [ _T("BPSlopeLo") ].ToLong ( &intValue );
        settingsBook->getFftBandPassSlopeLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BPBandHi")) )
    {
        m [ _T("BPBandHi") ].ToLong ( &intValue );
        settingsBook->getFftBandPassBandHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BPSlopeHi")) )
    {
        m [ _T("BPSlopeHi") ].ToLong ( &intValue );
        settingsBook->getFftBandPassSlopeHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BSBandLo")) )
    {
        m [ _T("BSBandLo") ].ToLong ( &intValue );
        settingsBook->getFftBandStopBandLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BSSlopeLo")) )
    {
        m [ _T("BSSlopeLo") ].ToLong ( &intValue );
        settingsBook->getFftBandStopSlopeLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BSBandHi")) )
    {
        m [ _T("BSBandHi") ].ToLong ( &intValue );
        settingsBook->getFftBandStopBandHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("BSSlopeHi")) )
    {
        m [ _T("BSSlopeHi") ].ToLong ( &intValue );
        settingsBook->getFftBandStopSlopeHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("LoudBandLo")) )
    {
        m [ _T("LoudBandLo") ].ToLong ( &intValue );
        settingsBook->getLoudnessBandLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("LoudBandHi")) )
    {
        m [ _T("LoudBandHi") ].ToLong ( &intValue );
        settingsBook->getLoudnessBandHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("LoudSlopeHi")) )
    {
        m [ _T("LoudSlopeHi") ].ToLong ( &intValue );
        settingsBook->getLoudnessSlopeHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("LoudCheckbox")) )
    {
        m [ _T("LoudCheckbox") ].ToLong ( &intValue );
        settingsBook->getLoudnessCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("DefaultSampleRadiobox")) )
    {
        m [ _T("DefaultSampleRadiobox") ].ToLong ( &intValue );
        settingsBook->getDefaultTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("MasterFilterTypesBox")) )
    {
        m [ _T("MasterFilterTypesBox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("MasterFilterBandLoSlider")) )
    {
        m [ _T("MasterFilterBandLoSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterBandLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterSlopeLoSlider")) )
    {
        m [ _T("MasterFilterSlopeLoSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterSlopeLoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterBandHiSlider")) )
    {
        m [ _T("MasterFilterBandHiSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterBandHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterSlopeHiSlider")) )
    {
        m [ _T("MasterFilterSlopeHiSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterSlopeHiSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterCheckbox")) )
    {
        m [ _T("MasterFilterCheckbox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterModulationTypesBox")) )
    {
        m [ _T("MasterFilterModulationTypesBox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterModulationTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("MasterFilterModulationDepthSlider")) )
    {
        m [ _T("MasterFilterModulationDepthSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterModulationDepthSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterLfoTypesBox")) )
    {
        m [ _T("MasterFilterLfoTypesBox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterLfoTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("MasterFilterLfoDepthSlider")) )
    {
        m [ _T("MasterFilterLfoDepthSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterLfoDepthSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterLfoPeriodsPerSliceSlider")) )
    {
        m [ _T("MasterFilterLfoPeriodsPerSliceSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterLfoCheckbox") ))
    {
        m [ _T("MasterFilterLfoCheckbox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterLfoCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterModulationCheckbox")) )
    {
        m [ _T("MasterFilterModulationCheckbox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterModulationCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterResonanceCheckbox")) )
    {
        m [ _T("MasterFilterResonanceCheckbox") ].ToLong ( &intValue );
        settingsBook->getMasterFilterResonanceCheckbox()->SetValue( intValue );
    }
    if ( m.count(_T("MasterFilterResonanceSlider")) )
    {
        m [ _T("MasterFilterResonanceSlider") ].ToLong ( &intValue );
        settingsBook->getMasterFilterResonanceSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayMultiTapDistance")) )
    {
        m [ _T("delayMultiTapDistance") ].ToLong ( &intValue );
        settingsBook->getDelayMultiTapDistanceSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayMultiTapStepNo")) )
    {
        m [ _T("delayMultiTapStepNo") ].ToLong ( &intValue );
        settingsBook->getDelayMultiTapStepNoSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayMultiTapGain")) )
    {
        m [ _T("delayMultiTapGain") ].ToLong ( &intValue );
        settingsBook->getDelayMultiTapGainSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayMultiTapFeedback")) )
    {
        m [ _T("delayMultiTapFeedback") ].ToLong ( &intValue );
        settingsBook->getDelayMultiTapFeedbackSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayVariableDistance")) )
    {
        m [ _T("delayVariableDistance") ].ToLong ( &intValue );
        settingsBook->getDelayVariableDistanceSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayVariableGain")) )
    {
        m [ _T("delayVariableGain") ].ToLong ( &intValue );
        settingsBook->getDelayVariableGainSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayVariableFeedback")) )
    {
        m [ _T("delayVariableFeedback") ].ToLong ( &intValue );
        settingsBook->getDelayVariableFeedbackSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayVariableLfoTypesBox")) )
    {
        m [ _T("delayVariableLfoTypesBox") ].ToLong ( &intValue );
        settingsBook->getDelayVariableLfoTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("delayVariableLfoDepth")) )
    {
        m [ _T("delayVariableLfoDepth") ].ToLong ( &intValue );
        settingsBook->getDelayVariableLfoDepthSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayVariableLfoPeriodsPerSlice")) )
    {
        m [ _T("delayVariableLfoPeriodsPerSlice") ].ToLong ( &intValue );
        settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->SetValue( intValue );
    }
    if ( m.count(_T("effectsChainGrid")) )
    {
        settingsBook->getEffectsChainGrid()->loadState ( m [ _T("effectsChainGrid") ] );
    }
    if ( m.count(_T("retriggerCountSlider")) )
    {
        m [ _T("retriggerCountSlider") ].ToLong ( &intValue );
        settingsBook->getRetriggerCountSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayPhasingDistanceOffsetSlider")) )
    {
        m [ _T("delayPhasingDistanceOffsetSlider") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingDistanceOffsetSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayPhasingDistanceRangeSlider")) )
    {
        m [ _T("delayPhasingDistanceRangeSlider") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingDistanceRangeSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayPhasingGainSlider")) )
    {
        m [ _T("delayPhasingGainSlider") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingGainSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayPhasingLfoTypesBox")) )
    {
        m [ _T("delayPhasingLfoTypesBox") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingLfoTypesBox()->SetSelection( intValue );
    }
    if ( m.count(_T("delayPhasingLfoDepthSlider")) )
    {
        m [ _T("delayPhasingLfoDepthSlider") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingLfoDepthSlider()->SetValue( intValue );
    }
    if ( m.count(_T("delayPhasingLfoPeriodsPerSliceSlider")) )
    {
        m [ _T("delayPhasingLfoPeriodsPerSliceSlider") ].ToLong ( &intValue );
        settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->SetValue( intValue );
    }


    manager->Update();
    mapGrid->Refresh();
    effectsGrid->Refresh();
    settingsBook->initPlotAreas();

    if ( !newData )
        return;

    pathValid = DoOpen ( fileIn );
    if ( pathValid )
        updateTitle ( fileIn );

}

void smasherFrame::initGridHighlightVector()
{
    std::fill ( gridHighlightVector.begin(), gridHighlightVector.end(), -1 );
}


void smasherFrame::OnAbout (wxCommandEvent &event)
{
    wxAboutDialogInfo info;
#ifndef __WXMSW__
    wxIcon icon;
    icon.CopyFromBitmap ( wxBitmap ( AppIcon::getPath(), wxBITMAP_TYPE_PNG ) );
	info.SetIcon ( icon );
#endif
    info.SetName(_("smasher") );
    info.SetVersion( SMASHER_VERSION_STRING );
    info.SetDescription(_("esther loeliger and gerald schmidt\n\nwxWidgets by Julian Smart et al. (http://www.wxwidgets.org)\nlibsndfile by Erik de Castro Lopo (http://www.mega-nerd.com/libsndfile)\nFFTReal by Laurent de Soras (http://ldesoras.free.fr)\nMPEG Audio Decoder and madplay by Binh Nguyen\nicons by gnome (http://www.gnome.org/)\namen break sampled by VEXST (www.freesound.org/samplesViewSingle.php?id=24940)\npiano sample by Raggaman (www.freesound.org/samplesViewSingle.php?id=25486)\nsynth loop by LS (www.freesound.org/samplesViewSingle.php?id=66381)"));
    info.AddDeveloper(_T("esther loeliger <eloeliger@users.sourceforge.net>"));
    info.AddDeveloper(_T("gerald schmidt <gnschmidt@users.sourceforge.net>"));
    info.SetCopyright(_T("copyright (c) 2009"));
    info.SetWebSite(_("http://smasher.sourceforge.net"));
    wxGenericAboutBox(info);
}

void smasherFrame::OnClose (wxCloseEvent &event)
{
    std::vector<wxString>::iterator it;
    for ( it = tempFiles.begin(); it != tempFiles.end(); it++ )
        wxRemove ( *it );

    Destroy();
}

#ifdef __WXMSW__
void smasherFrame::OnDropFiles ( wxDropFilesEvent& event )
{
    int no = event.GetNumberOfFiles();
    wxString *iterator = event.GetFiles();
    if ( !no || !iterator )
        return;

    for ( int i = 0; i < no; i++, iterator++ )
    {
        fileIn = *iterator;
        break;
    }

    pathValid = DoOpen ( fileIn );
    if ( pathValid )
        updateTitle ( fileIn );
}
#endif

void smasherFrame::OnGridColLeftClick ( wxGridEvent& event )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    int row, col;
    row = event.GetRow();
    col = event.GetCol();
    if ( row != -1 || col == -1 )
        return;

    initGridHighlightVector();

    std::vector<double> slice;
    std::string fileName;
    wxString wideFileName;

    WrapTempFileName wtfn;
    wtfn.setKeepFiles ( true );
    fileName = wtfn.name();
    wideFileName = wtfn.wideName();

    wideFileName += _T(".wav");
    fileName += ".wav";

    tempFiles.push_back ( wideFileName );

    size_t gateRange = 128;
    w->getSlice ( ( size_t )col, slice, gateRange );
    w->writeRawData ( (char *)fileName.c_str(), slice );

    play ( wideFileName /*, loopState */ );
}

void smasherFrame::OnFxOrderClear (wxCommandEvent& event)
{
    DoClearOrder ( effectsGrid );
}

void smasherFrame::OnFxOrderShuffleAll (wxCommandEvent& event)
{
    DoFxOrderShuffleAll();
}

void smasherFrame::OnFxOrderShuffleByKey (wxCommandEvent& event)
{
    DoFxOrderShuffleByKey( );
}

void smasherFrame::OnFxOrderSticky ( wxCommandEvent& event)
{
    DoFxOrderSticky();
}

void smasherFrame::OnIdle ( wxIdleEvent& event)
{
    if ( ++idleCounter % 2 )
        return;

    DoIdle();
}

void smasherFrame::OnKeyDown ( wxKeyEvent& event )
{
    int key = event.GetKeyCode();
    switch ( key )
    {
    case WXK_TAB:
        //std::cout << "TAB caught" << std::endl;
        //if ( mapToolbar->HasFocus() )
        if ( FindFocus() == ( wxWindow * ) sliceNoSpinControl )
            mapGrid->SetFocus();
        break;
    default:
        break;
    }
}

void smasherFrame::OnLoop (wxCommandEvent& event)
{
    DoLoop();
}

void smasherFrame::OnMediaFinished(wxMediaEvent& event)
{
    DoMediaFinished();
}

void smasherFrame::OnMediaLoaded(wxMediaEvent& event)
{
    DoMediaLoaded();
}

void smasherFrame::OnMediaStateChanged(wxMediaEvent& event)
{
    if ( closeDown )
        return;

    wxString state;
    switch ( getCurrentMediaCtrl()->GetState() )
    {
    case wxMEDIASTATE_PLAYING:
        state = _("playing");
        if ( isPlaySmashedButton )
            toolbar->ToggleTool ( ID_PLAY_SMASHED, true );
        else
            toolbar->ToggleTool ( ID_PLAY, true );
        toolbar->Realize();
        break;
    case wxMEDIASTATE_STOPPED:
        state = _("stopped");
        toolbar->ToggleTool ( ID_PLAY, false );
        toolbar->ToggleTool ( ID_PLAY_SMASHED, false );
        toolbar->Realize();
        gridColumnMemory = -1;
        mapGrid->clearHighlight();
        mapGrid->setPlaybackActive ( false );
        break;
    case wxMEDIASTATE_PAUSED:
        state = _("paused");
        break;
    default:
        state = wxEmptyString;
        break;
    }
    SetStatusText ( state, STATUS_PLAYBACK );
}

void smasherFrame::OnOpen (wxCommandEvent& event)
{
    wxString drive, directory;
    wxFileName::SplitPath ( fileIn, &drive, &directory, NULL, NULL );
    directory =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory;

    wxFileDialog fd ( this, _("Choose a file"), directory, wxEmptyString,
#ifdef __WXMSW__
                      _("All files (*.*)|*.*|WAV files (*.wav)|*.wav|MP3 files (*.mp3)|*.mp3|AIFF files (*.aiff)|*.aiff|FLAC files (*.flac)|*.flac")
#else
                      _("All files (*.*)|*|WAV files (*.wav)|*.wav|MP3 files (*.mp3)|*.mp3|AIFF files (*.aiff)|*.aiff|FLAC files (*.flac)|*.flac")
#endif

                    );
    if ( fd.ShowModal () == wxID_CANCEL )
        return;
    fileIn = fd.GetPath();
    pathValid = DoOpen ( fileIn );
    if ( pathValid )
        updateTitle ( fileIn );

}

void smasherFrame::OnPause ( wxCommandEvent& event )
{
    DoPause();
}

void smasherFrame::OnPlay (wxCommandEvent& event)
{
    initGridHighlightVector();

    isPlaySmashedButton = false;
    if ( toolbar->GetToolToggled ( ID_PLAY_SMASHED ) )
        toolbar->ToggleTool ( ID_PLAY_SMASHED, false );

    std::string file = (const char *) fileIn.mb_str( wxConvUTF8 );
    handleMp3 ( file );
    wxString wideFile = wxString ( file.c_str(), wxConvUTF8, file.size() );
    if ( !play ( wideFile /*, loopState */ ) )
        return;
    toolbar->ToggleTool ( ID_PLAY, true );
    toolbar->Realize();
}

void smasherFrame::OnPlaySmashed (wxCommandEvent& event)
{
    int colNo, rowNo;
    colNo = mapGrid->GetNumberCols();
    rowNo = mapGrid->GetNumberRows();

    initGridHighlightVector();

    for ( int i = 0; i < colNo; i++ )
    {
        for ( int j = 0; j < rowNo; j++ )
        {
            if ( mapGrid->isSelected ( j, i ) )
                gridHighlightVector[i] = j;
        }
    }

    isPlaySmashedButton = true;
    if ( toolbar->GetToolToggled ( ID_PLAY ) )
        toolbar->ToggleTool ( ID_PLAY, false );

    if ( !DoPlaySmashed ( -1 ) )
        return;
    toolbar->ToggleTool ( ID_PLAY_SMASHED, true );
    toolbar->Realize();
}

void smasherFrame::OnRestoreDefault ( wxCommandEvent& event)
{
    wxString state = defaultStates->at ( settingsBook->getDefaultTypesBox()->GetSelection() );
    loadState ( state, true );
}

void smasherFrame::OnQuit (wxCommandEvent &event)
{
    Destroy();
}

void smasherFrame::OnSave ( wxCommandEvent& event )
{
    wxString drive, directory;
    wxFileName::SplitPath ( fileIn, &drive, &directory, NULL, NULL );
    directory =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory;


    std::auto_ptr<wxFileDialog> fd ( new wxFileDialog (
                                         this,
                                         _ ( "Save As" ),
                                         directory,
                                         wxEmptyString,
#ifdef __WXMSW__
                                        _T("All files (*.*)|*.*|WAV files (*.wav)|*.wav")
#else
                                        _T("All files (*.*)|*|WAV files (*.wav)|*.wav")
#endif
                                        , wxSAVE | wxOVERWRITE_PROMPT ) );
    if ( fd->ShowModal() != wxID_OK )
        return;

    wxString path = fd->GetPath();

    int index = fd->GetFilterIndex();
    wxString filter;
    switch ( index )
    {
        case 0:
        case 1:
            filter = _T(".wav");
            break;
        default:
            filter = _T(".wav");
            break;
    }

    if ( ! path.Lower().Contains ( filter ) )
        path.Append ( filter );

    waitForThreadsToFinish();

    if ( w->getState() != WAV16_HAS_DATA_OUT )
    {
        std::cout << "OnSave: w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
        SetStatusText ( _("can't save file") );
        return;
    }

    std::string fileOut;

    if ( path.empty() )
        return;

    fileOut = (const char *) path.mb_str( wxConvUTF8 );

    if ( !w->write ( ( char * ) fileOut.c_str() ))
        SetStatusText ( _("can't write file to disk" ) );

}

void smasherFrame::OnLoadMachineState ( wxCommandEvent& event )
{
    wxFileDialog fd ( this, _("Choose a file"), wxEmptyString, wxEmptyString,
#ifdef __WXMSW__
                      _("All files (*.*)|*.*|SMASH files (*.smash)|*.smash")
#else
                      _("All files (*.*)|*|SMASH files (*.smash)|*.smash")
#endif
                    );
    if ( fd.ShowModal () == wxID_CANCEL )
        return;

    wxString statePath = fd.GetPath();
    if ( statePath.empty() )
        return;

    BinaryFile bf ( statePath.mb_str( wxConvUTF8 ) );

    wxString state = wxString ( bf.getData(), wxConvUTF8, bf.getDataLen() );

    loadState ( state, true );
}

void smasherFrame::OnSaveMachineState(wxCommandEvent& event)
{
    std::auto_ptr<wxFileDialog> fd ( new wxFileDialog (
                                         this,
                                         _ ( "save machine state" ),
                                         wxEmptyString,
                                         wxEmptyString,
                                         _T("*.smash"),
                                         wxSAVE | wxOVERWRITE_PROMPT ) );
    if ( fd->ShowModal() != wxID_OK )
        return;

    wxString path = fd->GetPath();
    if ( path.empty() )
        return;

    int index = fd->GetFilterIndex();
    wxString filter;
    switch ( index )
    {
        case 0:
            filter = _T(".smash");
            break;
        default:
            filter = _T(".smash");
            break;
    }

    if ( ! path.Lower().Contains ( filter ) )
        path.Append ( filter );


    wxString state = saveState();

    std::string fileOutName;
    fileOutName = (const char *) path.mb_str( wxConvUTF8 );
    std::ofstream file ( fileOutName.c_str() );
    if ( !file.is_open() )
    {
        SetStatusText ( _("can't save file") );
        return;
    }
    file << ( const char *) state.mb_str( wxConvUTF8 );
    file.close();
    SetStatusText ( _("saved machine state to disk") );
}

void smasherFrame::OnSettingsChanged (wxTreebookEvent& event)
{
    event.Skip();
}

void smasherFrame::OnShowEffects (wxCommandEvent& event)
{
    DoShowEffects ( );
}

void smasherFrame::OnShowLog (wxCommandEvent& event)
{
    DoShowLog ();
}

void smasherFrame::OnShowPlot (wxCommandEvent& event)
{
    DoShowPlot ();
}

void smasherFrame::OnShowSettings (wxCommandEvent& event)
{
    DoShowSettings ();
}

void smasherFrame::OnShowTransportOnly ( wxCommandEvent& event)
{
    DoShowTransportOnly ();
}

void smasherFrame::OnSliceNoChange (wxSpinEvent& event)
{
    DoSliceNoChange ();
}

void smasherFrame::OnSliceOrder1ToN (wxCommandEvent& event)
{
    DoSliceOrder1ToN ( mapGrid );
}

void smasherFrame::OnSliceOrderClear (wxCommandEvent& event)
{
    DoClearOrder( mapGrid );
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ));
    DoClearOrder ( effectsGrid );
}

void smasherFrame::OnSliceOrderNTo1 (wxCommandEvent& event)
{
    DoSliceOrderNTo1 ( mapGrid );
}

void smasherFrame::OnSliceOrderShuffleAll (wxCommandEvent& event)
{
    DoSliceOrderShuffleAll ( mapGrid );
}

void smasherFrame::OnSliceOrderShuffleByKey (wxCommandEvent& event)
{
    DoSliceOrderShuffleByKey ( mapGrid );
}

void smasherFrame::OnSliceOrderRotateLeft (wxCommandEvent& event)
{
    mapGrid->rotateLeft();
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        effectsGrid->rotateLeft();

    manager->Update ();
}

void smasherFrame::OnSliceOrderRotateRight (wxCommandEvent& event)
{
    mapGrid->rotateRight();
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        effectsGrid->rotateRight();
    manager->Update ();
}

#ifndef __WXMSW__
void smasherFrame::OnVolumeChanged ( wxScrollEvent& event )
#else
void smasherFrame::OnVolumeChanged ( wxSpinEvent& event )
#endif
{
    DoVolumeChanged();
}

void smasherFrame::OnTogglePlay(wxCommandEvent& event)
{
    if ( pauseState || toolbar->GetToolToggled( ID_PLAY ) || toolbar->GetToolToggled( ID_PLAY_SMASHED ))
    {
        OnPause ( event );
        return;
    }
    if ( isPlaySmashedButton )
    {
        OnPlaySmashed ( event );
        return;
    }
    OnPlay ( event );
}


void smasherFrame::OnStop (wxCommandEvent& event)
{
    DoStop();
}

void smasherFrame::OnRedo ( wxCommandEvent& event)
{
    wxString newState = history.redo();
    if ( ! newState.empty() )
    {
        loadState ( newState );
    }
    stateMemory = newState;

    waitForThreadsToFinish();
    smashSync();
    updatePlotArea();
}

void smasherFrame::OnUndo ( wxCommandEvent& event)
{
    wxString newState = history.undo();
    if ( ! newState.empty() )
    {
        loadState ( newState );
    }
    stateMemory = newState;

    waitForThreadsToFinish();
    smashSync();
    updatePlotArea();
}

void smasherFrame::OnUpdateRedo ( wxUpdateUIEvent& event )
{
    event.Enable ( history.canRedo() );
}

void smasherFrame::OnUpdateUndo ( wxUpdateUIEvent& event )
{
    event.Enable ( history.canUndo() );
}

void smasherFrame::OnUpdateThreadRunning ( wxUpdateUIEvent& event )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );
    event.Enable ( threadState != SMASH_THREAD_RUNNING );
}

void smasherFrame::OnUpdatePaneMaximized ( wxUpdateUIEvent& event )
{
    bool enable;
    if ( toolbar->GetToolToggled ( ID_SHOW_TRANSPORT_ONLY ) )
        enable = false;
    else
        enable = !paneIsMaximized();

    event.Enable( enable );
}

bool smasherFrame::paneIsMaximized()
{
    return ( ( manager->GetPane( effectsGrid ).IsMaximized() ) ||
#ifdef SMASHER_DEBUG
             ( manager->GetPane( logText ).IsMaximized()) ||
#endif
             ( manager->GetPane( settingsBook ).IsMaximized()) ||
             ( manager->GetPane( mapGrid ).IsMaximized()) ||
             ( manager->GetPane( lPlot ).IsMaximized()) ||
             ( manager->GetPane( rPlot ).IsMaximized()));
}

bool smasherFrame::play (wxString& fileName /* , bool loop */ )
{
    try
    {
        if ( pauseState )
        {
            mediaCtrl->Stop();
            mediaCtrlAlt->Stop();
            DoPause();
        }

        if ( !getCurrentMediaCtrl()->Load ( fileName ) )
        {
            std::cout << "play: media ctrl can't load wave" << std::endl;
            return false;
        }

        if ( !getAlternativeMediaCtrl()->Load ( fileName ) )
        {
            std::cout << "play: alternative media ctrl can't load wave" << std::endl;
            return false;
        }

        mapGrid->setPlaybackActive ( true );

        return true;

        /* wxSound implementation
            if ( fileName.empty() ) {
                throw std::runtime_error ( "smasherFrame::play() - empty fileName" );
            }
            wxSound s ( fileName );
            if ( ! s.IsOk() )
            {
                throw std::runtime_error ( "smasherFrame::play() - can't load fileIn" );
            }
            return s.Play ( loop ? wxSOUND_ASYNC | wxSOUND_LOOP : wxSOUND_ASYNC );
         */
    }
    catch (std::exception &e)
    {
        std::cout << "play: " << e.what() << std::endl;
        return false;
    }
}

void smasherFrame::addTransformers( std::vector<size_t>& posVector )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    w->clearEffectsInfo();

    std::vector<wxString> chainVector;
    settingsBook->getEffectsChainGrid()->getChainVector ( &chainVector );

    if ( chainVector.empty() )
        return;

    size_t chainVectorSize = chainVector.size();
    wxString currentEffect;
    std::vector<size_t> effectsPositionVector;
    for ( size_t i = 0; i < chainVectorSize; i++ )
    {
        currentEffect = chainVector.at ( i );
        effectsPositionVector.clear();

        if ( currentEffect == _("distort") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *distortTransformer;
                distortTransformer = ( SliceTransformer<double> * )
                                     new SliceDistortTransformer<double> (
                                         settingsBook->getDistortCutoffSlider()->GetValue(),
                                         settingsBook->getDistortRangeSlider()->GetValue(),
                                         settingsBook->getDistortAmplificationFactorSlider()->GetValue(),
                                         w->getChannels () );
                SliceVectorTransformer<double> *distortTransformerV;
                distortTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    distortTransformer );
                w->addSliceVectorTransformer ( distortTransformerV );
            }
        }

        else if ( currentEffect == _("reverse") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *reverseTransformer;
                reverseTransformer = ( SliceTransformer<double> * )
                                     new SliceReverseTransformer<double>( w->getChannels () );
                SliceVectorTransformer<double> *reverseTransformerV;
                reverseTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    reverseTransformer );
                w->addSliceVectorTransformer ( reverseTransformerV );
            }
        }

        else if ( currentEffect == _( "bitcrush" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *bitCrushTransformer;
                bitCrushTransformer = ( SliceTransformer<double> * )
                                      new SliceBitCrushTransformer<double> (
                                          settingsBook->getBitCrushTypesBox()->GetSelection(),
                                          w->getChannels () );
                SliceVectorTransformer<double> *bitCrushTransformerV;
                bitCrushTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    bitCrushTransformer);
                w->addSliceVectorTransformer ( bitCrushTransformerV );
            }
        }

        else if ( currentEffect == _("tap delay") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                double delay = (double)( settingsBook->getDelayMultiTapDistanceSlider()->GetValue() ) * 0.01;
                size_t steps = settingsBook->getDelayMultiTapStepNoSlider()->GetValue();
                double gain =  settingsBook->getDelayMultiTapGainSlider()->GetValue() * 0.1;
                size_t feedbackLoops = ( size_t ) settingsBook->getDelayMultiTapFeedbackSlider()->GetValue();
                SliceTransformer<double> *delayTransformer;
                delayTransformer = ( SliceTransformer<double> * )
                                   new SliceDelayTransformer<double> (
                                       delay,
                                       steps,
                                       gain,
                                       feedbackLoops,
                                       w->getChannels () );
                SliceVectorTransformer<double>  *delayTransformerV;
                delayTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayTransformer);
                w->addSliceVectorTransformer ( delayTransformerV );
            }
        }

        else if ( currentEffect == _("retrigger") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *retriggerTransformer;
                retriggerTransformer = ( SliceTransformer<double> * )
                new SliceRetriggerTransformer<double> (
                    settingsBook->getRetriggerCountSlider()->GetValue() );
                SliceVectorTransformer<double>  *retriggerTransformerV;
                retriggerTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    retriggerTransformer);
                w->addSliceVectorTransformer ( retriggerTransformerV );
            }
        }

        else if ( currentEffect == _( "flanging" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );

            if ( !effectsPositionVector.empty() )
            {
                size_t delay = ( size_t ) settingsBook->getDelayVariableDistanceSlider()->GetValue();
                size_t feedbackLoopNo = ( size_t ) settingsBook->getDelayVariableFeedbackSlider()->GetValue();
                int lfoType = settingsBook->getDelayVariableLfoTypesBox()->GetSelection();
                double gain =  ( double ) settingsBook->getDelayVariableGainSlider()->GetValue() * 0.1;
                double lfoDepth = ( double ) settingsBook->getDelayVariableLfoDepthSlider()->GetValue() * 0.01;
                double lfoPeriodsPerSlice = ( double ) settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->GetValue() * 0.01;
                SliceTransformer<double> *delayVariableTransformer;
                delayVariableTransformer = ( SliceTransformer<double> * )
                                           new SliceDelayVariableTransformer<double> (
                                               delay,
                                               feedbackLoopNo,
                                               w->getChannels (),
                                               lfoType,
                                               gain,
                                               lfoDepth,
                                               lfoPeriodsPerSlice );
                SliceVectorTransformer<double> *delayVariableTransformerV;
                delayVariableTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayVariableTransformer);
                w->addSliceVectorTransformer ( delayVariableTransformerV );
            }
        }

        else if ( currentEffect == _( "phasing" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );

            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *delayPhaseTransformer;
                delayPhaseTransformer = ( SliceTransformer<double> * )
                                           new SliceDelayPhaseTransformer<double> (
                                               (( double ) settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue() )/ 22050.0,
                                               (( double ) settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue() )/ 22050.0,
                                               settingsBook->getDelayPhasingLfoTypesBox()->GetSelection(),
                                               ( double ) settingsBook->getDelayPhasingLfoDepthSlider()->GetValue() * 0.01,
                                               ( double ) settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue() * 0.01,
                                               w->getChannels(),
                                               ( double ) settingsBook->getDelayPhasingGainSlider()->GetValue() * 0.1,
                                               0 );

                SliceVectorTransformer<double> *delayPhaseTransformerV;
                delayPhaseTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayPhaseTransformer);
                w->addSliceVectorTransformer ( delayPhaseTransformerV );
            }
        }

        else if ( currentEffect == _("downsample") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *downSampleTransformer;
                downSampleTransformer = ( SliceTransformer<double> * )
                                        new SliceDownSampleTransformer<double> (
                                            settingsBook->getDownSampleTypesBox()->GetSelection(),
                                            w->getChannels () );
                SliceVectorTransformer<double> *downSampleTransformerV;
                downSampleTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    downSampleTransformer);
                w->addSliceVectorTransformer ( downSampleTransformerV );
            }
        }

        else if ( currentEffect == _("tapestop") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *tapestopTransformer;
                tapestopTransformer = ( SliceTransformer<double> * )
                                      new SliceTapestopTransformer<double> ( w->getChannels () );
                SliceVectorTransformer<double> *tapestopTransformerV;
                tapestopTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    tapestopTransformer);
                w->addSliceVectorTransformer ( tapestopTransformerV );
            }
        }

        else if ( currentEffect == _("fade in") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fadeInTransformer;
                fadeInTransformer = ( SliceTransformer<double> * )
                                    new SliceFadeTransformer<double> (
                                        settingsBook->getFadeInRangeSlider()->GetValue(),
                                        w->getChannels (),
                                        FADE_IN,
                                        settingsBook->getFadeInTypesBox()->GetSelection() );
                SliceVectorTransformer<double> *fadeInTransformerV;
                fadeInTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    fadeInTransformer);
                w->addSliceVectorTransformer ( fadeInTransformerV );
            }
        }

        else if ( currentEffect == _("fade out") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fadeOutTransformer;
                fadeOutTransformer = ( SliceTransformer<double> * )
                                     new SliceFadeTransformer<double> (
                                         settingsBook->getFadeOutRangeSlider()->GetValue(),
                                         w->getChannels (),
                                         FADE_OUT,
                                         settingsBook->getFadeOutTypesBox()->GetSelection() );
                SliceVectorTransformer<double> *fadeOutTransformerV;
                fadeOutTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    fadeOutTransformer);
                w->addSliceVectorTransformer ( fadeOutTransformerV );
            }
        }

        else if ( currentEffect == _("tremolo") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *tremoloTransformer;
                tremoloTransformer = ( SliceTransformer<double> * )
                                     new SliceTremoloTransformer<double> (
                                         settingsBook->getTremoloTypesBox()->GetSelection(),
                                         (double)( settingsBook->getTremoloDepthSlider()->GetValue() ) * 0.01,
                                         settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue(),
                                         settingsBook->getTremoloStereoModeBox()->GetSelection(),
                                         w->getChannels () );
                SliceVectorTransformer<double> *tremoloTransformerV;
                tremoloTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    tremoloTransformer);
                w->addSliceVectorTransformer ( tremoloTransformerV );
            }
        }

        else if ( currentEffect == _("phasing") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *delayPhaseTransformer;
                delayPhaseTransformer = ( SliceTransformer<double> * )
                                     new SliceDelayPhaseTransformer<double> (
                                         settingsBook->getTremoloTypesBox()->GetSelection(),
                                         (double)( settingsBook->getTremoloDepthSlider()->GetValue() ) * 0.01,
                                         settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue(),
                                         w->getChannels () );
                SliceVectorTransformer<double> *delayPhaseTransformerV;
                delayPhaseTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayPhaseTransformer);
                w->addSliceVectorTransformer ( delayPhaseTransformerV );
            }
        }

        else if ( currentEffect == _("lowpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftLowPassTransformer;
                fftLowPassTransformer = ( SliceTransformer<double> * )
                                        new SliceFFTTransformer<double> (
                                            FFT_LOWPASS,
                                            0.0,
                                            0.0,
                                            ( settingsBook->getFftLowPassBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                            ( settingsBook->getFftLowPassSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                            w->getChannels () );

                SliceVectorTransformer<double> *fftLowPassTransformerV;
                fftLowPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftLowPassTransformer );
                w->addSliceVectorTransformer ( fftLowPassTransformerV );
            }
        }

        else if ( currentEffect == _("highpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftHiPassTransformer;
                fftHiPassTransformer = ( SliceTransformer<double> * )
                                       new SliceFFTTransformer<double> (
                                           FFT_HIGHPASS,
                                           ( settingsBook->getFftHighPassBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                           ( settingsBook->getFftHighPassSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                           0 * 0.5 / 22050,
                                           0 * 0.5 / 22050,
                                           w->getChannels () );
                SliceVectorTransformer<double> *fftHiPassTransformerV;
                fftHiPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftHiPassTransformer );
                w->addSliceVectorTransformer ( fftHiPassTransformerV );
            }
        }

        else if ( currentEffect == _("bandpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftBandPassTransformer;
                fftBandPassTransformer = ( SliceTransformer<double> * )
                                         new SliceFFTTransformer<double> (
                                             FFT_BANDPASS,
                                             ( settingsBook->getFftBandPassBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                             w->getChannels () );
                SliceVectorTransformer<double> *fftBandPassTransformerV;
                fftBandPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftBandPassTransformer );
                w->addSliceVectorTransformer ( fftBandPassTransformerV );
            }
        }

        else if ( currentEffect == _("bandstop") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftBandStopTransformer;
                fftBandStopTransformer = ( SliceTransformer<double> * )
                                         new SliceFFTTransformer<double> (
                                             FFT_BANDSTOP,
                                             ( settingsBook->getFftBandStopBandLoSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopSlopeLoSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopBandHiSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopSlopeHiSlider()->GetValue()) * 0.5 / 22050,
                                             w->getChannels () );
                SliceVectorTransformer<double> *fftBandStopTransformerV;
                fftBandStopTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftBandStopTransformer );
                w->addSliceVectorTransformer ( fftBandStopTransformerV );
            }
        }

        else if ( currentEffect == _("master filter") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                double resonanceMax, modulationDepth, lfoDepth;
                int modulationType, lfoType;
                size_t lfoPeriodsPerSlice = 0;
                modulationType = FFT_MOD_NONE;
                lfoType = FFT_LFO_NONE;
                resonanceMax = modulationDepth = lfoDepth = 0.0;

                if ( settingsBook->getMasterFilterResonanceCheckbox()->IsChecked() )
                    resonanceMax = settingsBook->getMasterFilterResonanceSlider()->GetValue();

                if ( settingsBook->getMasterFilterModulationCheckbox()->IsChecked() )
                {
                    modulationType = settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
                    modulationDepth = settingsBook->getMasterFilterModulationDepthSlider()->GetValue() * 0.01;
                }

                if ( settingsBook->getMasterFilterLfoCheckbox()->IsChecked() )
                {
                    lfoType = settingsBook->getMasterFilterLfoTypesBox()->GetSelection(),
                              lfoDepth = settingsBook->getMasterFilterLfoDepthSlider()->GetValue() * 0.01;
                    lfoPeriodsPerSlice = settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
                }

                SliceTransformer<double> *masterFilterTransformer;
                masterFilterTransformer = ( SliceTransformer<double> * )
                                          new SliceFFTWindowedTransformer<double> (
                                              settingsBook->getMasterFilterTypesBox()->GetSelection(),
                                              modulationType,
                                              lfoType,
                                              ( settingsBook->getMasterFilterBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                              1024,
                                              modulationDepth,
                                              lfoDepth,
                                              resonanceMax,
                                              lfoPeriodsPerSlice,
                                              w->getChannels () );

                SliceVectorTransformer<double> *masterFilterTransformerV;
                masterFilterTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    masterFilterTransformer);
                w->addSliceVectorTransformer ( masterFilterTransformerV );
            }
        }
    }


    /************ F I L T E R ***********************************************************/

    if ( settingsBook->getGateCheckbox()->IsChecked() )
    {
        SliceTransformer<double> *gateTransformer;
        gateTransformer =  ( SliceTransformer<double> * )
                           new SliceGateTransformer<double> (
                               w->getDataInPtr()->size(),
                               64,
                               w->getChannels () );
        w->addSliceTransformer ( gateTransformer );
    }

    if ( settingsBook->getPitchAdjustCheckbox()->IsChecked() )
    {
        SliceTransformer<double> *pitchTransformer;
        pitchTransformer = ( SliceTransformer<double> * )
                           new SlicePitchTransformer<double> (
                               settingsBook->getPitchSemitonesSlider()->GetValue(),
                               w->getChannels () );
        w->addSliceTransformer ( pitchTransformer );
    }

    if ( settingsBook->getNormalizeCheckbox()->IsChecked() )
    {
        SliceTransformer<double> *normalizeTransformer;
        normalizeTransformer = ( SliceTransformer<double> * )
                               new SliceNormalizeTransformer<double> (
                                   ( settingsBook->getNormalizeSlider()->GetValue()) * 0.01,
                                   w->getChannels () );
        w->addSliceTransformer ( normalizeTransformer );
    }

    if ( settingsBook->getLoudnessCheckbox()->IsChecked() )
    {
        SliceTransformer<double> *fftLoudnessTransformer;
        fftLoudnessTransformer = ( SliceTransformer<double> * )
                                 new SliceFFTTransformer<double> (
                                     FFT_BANDSTOP,
                                     ( settingsBook->getLoudnessBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                     ( settingsBook->getLoudnessSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                     ( settingsBook->getLoudnessBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                     ( settingsBook->getLoudnessSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                     w->getChannels () );
        w->addSliceTransformer ( fftLoudnessTransformer );
    }

    if ( settingsBook->getMasterFilterCheckbox()->IsChecked() )
    {
        double resonanceMax, modulationDepth, lfoDepth;
        int modulationType, lfoType;
        size_t lfoPeriodsPerSlice = 0;
        modulationType = FFT_MOD_NONE;
        lfoType = FFT_LFO_NONE;
        resonanceMax = modulationDepth = lfoDepth = 0.0;

        if ( settingsBook->getMasterFilterResonanceCheckbox()->IsChecked() )
            resonanceMax = settingsBook->getMasterFilterResonanceSlider()->GetValue();

        if ( settingsBook->getMasterFilterModulationCheckbox()->IsChecked() )
        {
            modulationType = settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
            modulationDepth = settingsBook->getMasterFilterModulationDepthSlider()->GetValue() * 0.01;
        }

        if ( settingsBook->getMasterFilterLfoCheckbox()->IsChecked() )
        {
            lfoType = settingsBook->getMasterFilterLfoTypesBox()->GetSelection(),
                      lfoDepth = settingsBook->getMasterFilterLfoDepthSlider()->GetValue() * 0.01;
            lfoPeriodsPerSlice = settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
        }

        SliceTransformer<double> *fftMasterFilterTransformer;
        fftMasterFilterTransformer = ( SliceTransformer<double> * )
                                     new SliceFFTWindowedTransformer<double> (
                                         settingsBook->getMasterFilterTypesBox()->GetSelection(),
                                         modulationType,
                                         lfoType,
                                         ( settingsBook->getMasterFilterBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                         ( settingsBook->getMasterFilterSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                         ( settingsBook->getMasterFilterBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                         ( settingsBook->getMasterFilterSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                         1024,
                                         modulationDepth,
                                         lfoDepth,
                                         resonanceMax,
                                         lfoPeriodsPerSlice,
                                         w->getChannels () );
        w->addSliceTransformer ( fftMasterFilterTransformer );
    }


    if ( settingsBook->getCompressCheckbox()->IsChecked() )
    {
        SliceTransformer<double> *compressTransformer;
        compressTransformer = ( SliceTransformer<double> * )
                              new SliceCompressTransformer<double> (
                                  settingsBook->getCompressCutoffSlider()->GetValue() * 0.01,
                                  settingsBook->getCompressRangeSlider()->GetValue() * 0.01,
                                  w->getChannels () );
        w->addSliceTransformer ( compressTransformer );
    }
}

wxString smasherFrame::saveState ( )
{
    wxString s;
    s += _T("fileIn=");
    s += fileIn;
    s += _T("|sliceNo=");
    s << sliceNoSpinControl->GetValue();
    s += _T("|mapGrid=");
    s += mapGrid->saveState();

    wxString name, posVectorString;
    std::vector<size_t> positionVector;
    size_t effectsVectorSize = effectsVector.size();
    size_t sliceCount = mapGrid->GetNumberCols();
    std::set<size_t> positionLookup;

    for ( size_t i = 0; i < effectsVectorSize; i++ )
    {
        name = effectsVector.at ( i );
        effectsGrid->getNamedPositionVector ( name, positionVector );
        std::vector<size_t>::iterator it;
        for ( it = positionVector.begin(); it != positionVector.end(); it++ )
            positionLookup.insert ( *it );

        for ( size_t j = 0; j < sliceCount; j++ )
        {
            if ( positionLookup.count ( j ) != 0 )
                posVectorString += _T("1");
            else
                posVectorString += _T("0");
        }

        s += _T("|");
        s += name;
        s += _T("=");
        s += posVectorString;
        posVectorString.clear();
        positionVector.clear();
        positionLookup.clear();
    }

    s += _T("|tremoloDepth=");
    s << settingsBook->getTremoloDepthSlider()->GetValue();
    s += _T("|tremoloPeriodsPerSlice=");
    s << settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue();
    s += _T("|tremoloType=");
    s << settingsBook->getTremoloTypesBox()->GetSelection();
    s += _T("|tremoloStereoMode=");
    s << settingsBook->getTremoloStereoModeBox()->GetSelection();
    s += _T("|fadeInRange=");
    s << settingsBook->getFadeInRangeSlider()->GetValue();
    s += _T("|fadeInType=");
    s << settingsBook->getFadeInTypesBox()->GetSelection();
    s += _T("|fadeOutRange=");
    s << settingsBook->getFadeOutRangeSlider()->GetValue();
    s += _T("|fadeOutType=");
    s << settingsBook->getFadeOutTypesBox()->GetSelection();
    s += _T("|delayMultiTapDistance=");
    s << settingsBook->getDelayMultiTapDistanceSlider()->GetValue();
    s += _T("|delayMultiTapStepNo=");
    s << settingsBook->getDelayMultiTapStepNoSlider()->GetValue();
    s += _T("|delayMultiTapGain=");
    s << settingsBook->getDelayMultiTapGainSlider()->GetValue();
    s += _T("|delayMultiTapFeedback=");
    s << settingsBook->getDelayMultiTapFeedbackSlider()->GetValue();
    s += _T("|delayVariableDistance=");
    s << settingsBook->getDelayVariableDistanceSlider()->GetValue();
    s += _T("|delayVariableGain=");
    s << settingsBook->getDelayVariableGainSlider()->GetValue();
    s += _T("|delayVariableFeedback=");
    s << settingsBook->getDelayVariableFeedbackSlider()->GetValue();
    s += _T("|delayVariableLfoTypesBox=");
    s << settingsBook->getDelayVariableLfoTypesBox()->GetSelection();
    s += _T("|delayVariableLfoDepth=");
    s << settingsBook->getDelayVariableLfoDepthSlider()->GetValue();
    s += _T("|delayVariableLfoPeriodsPerSlice=");
    s << settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->GetValue();
    s += _T("|delayPhasingDistanceOffset=");
    s << settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue();
    s += _T("|delayPhasingDistanceRangeSlider=");
    s << settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue();
    s += _T("|delayPhasingGainSlider=");
    s << settingsBook->getDelayPhasingGainSlider()->GetValue();
    s += _T("|delayPhasingLfoTypesBox=");
    s << settingsBook->getDelayPhasingLfoTypesBox()->GetSelection();
    s += _T("|delayPhasingLfoDepthSlider=");
    s << settingsBook->getDelayPhasingLfoDepthSlider()->GetValue();
    s += _T("|delayPhasingLfoPeriodsPerSliceSlider=");
    s << settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue();
    s += _T("|distortCutoff=");
    s << settingsBook->getDistortCutoffSlider()->GetValue();
    s += _T("|distortRange=");
    s << settingsBook->getDistortRangeSlider()->GetValue();
    s += _T("|distortAmplificationFactor=");
    s << settingsBook->getDistortAmplificationFactorSlider()->GetValue();
    s += _T("|bitCrusherType=");
    s << settingsBook->getBitCrushTypesBox()->GetSelection();
    s += _T("|downSampleType=");
    s << settingsBook->getDownSampleTypesBox()->GetSelection();
    s += _T("|shuffleKey=");
    s << settingsBook->getKeyTextCtrl()->GetValue();
    s += _T("|pitchSemitones=");
    s << settingsBook->getPitchSemitonesSlider()->GetValue();
    s += _T("|pitchAdjust=");
    s << settingsBook->getPitchAdjustCheckbox()->IsChecked();
    s += _T("|normalizeTo=");
    s << settingsBook->getNormalizeSlider()->GetValue();
    s += _T("|normalize=");
    s << settingsBook->getNormalizeCheckbox()->IsChecked();
    s += _T("|compressCutoff=");
    s << settingsBook->getCompressCutoffSlider()->GetValue();
    s += _T("|compressRange=");
    s << settingsBook->getCompressRangeSlider()->GetValue();
    s += _T("|compress=");
    s << settingsBook->getCompressCheckbox()->IsChecked();
    s += _T("|gate=");
    s << settingsBook->getGateCheckbox()->IsChecked();
    s += _T("|LPBandHi=");
    s << settingsBook->getFftLowPassBandHiSlider()->GetValue();
    s += _T("|LPSlopeHi=");
    s << settingsBook->getFftLowPassSlopeHiSlider()->GetValue();
    s += _T("|HPBandLo=");
    s << settingsBook->getFftHighPassBandLoSlider()->GetValue();
    s += _T("|HPSlopeLo=");
    s << settingsBook->getFftHighPassSlopeLoSlider()->GetValue();
    s += _T("|BPBandLo=");
    s << settingsBook->getFftBandPassBandLoSlider()->GetValue();
    s += _T("|BPSlopeLo=");
    s << settingsBook->getFftBandPassSlopeLoSlider()->GetValue();
    s += _T("|BPBandHi=");
    s << settingsBook->getFftBandPassBandHiSlider()->GetValue();
    s += _T("|BPSlopeHi=");
    s << settingsBook->getFftBandPassSlopeHiSlider()->GetValue();
    s += _T("|BSBandLo=");
    s << settingsBook->getFftBandStopBandLoSlider()->GetValue();
    s += _T("|BSSlopeLo=");
    s << settingsBook->getFftBandStopSlopeLoSlider()->GetValue();
    s += _T("|BSBandHi=");
    s << settingsBook->getFftBandStopBandHiSlider()->GetValue();
    s += _T("|BSSlopeHi=");
    s << settingsBook->getFftBandStopSlopeHiSlider()->GetValue();
    s += _T("|LoudBandLo=");
    s << settingsBook->getLoudnessBandLoSlider()->GetValue();
    s += _T("|LoudBandHi=");
    s << settingsBook->getLoudnessBandHiSlider()->GetValue();
    s += _T("|LoudSlopeHi=");
    s << settingsBook->getLoudnessSlopeHiSlider()->GetValue();
    s += _T("|LoudCheckbox=");
    s << settingsBook->getLoudnessCheckbox()->IsChecked();
    s += _T("|DefaultSampleRadiobox=");
    s << settingsBook->getDefaultTypesBox()->GetSelection();
    s += _T("|MasterFilterTypesBox=");
    s << settingsBook->getMasterFilterTypesBox()->GetSelection();
    s += _T("|MasterFilterBandLoSlider=");
    s << settingsBook->getMasterFilterBandLoSlider()->GetValue();
    s += _T("|MasterFilterSlopeLoSlider=");
    s << settingsBook->getMasterFilterSlopeLoSlider()->GetValue();
    s += _T("|MasterFilterBandHiSlider=");
    s << settingsBook->getMasterFilterBandHiSlider()->GetValue();
    s += _T("|MasterFilterSlopeHiSlider=");
    s << settingsBook->getMasterFilterSlopeHiSlider()->GetValue();
    s += _T("|MasterFilterCheckbox=");
    s << settingsBook->getMasterFilterCheckbox()->IsChecked();
    s += _T("|MasterFilterModulationTypesBox=");
    s << settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
    s += _T("|MasterFilterModulationDepthSlider=");
    s << settingsBook->getMasterFilterModulationDepthSlider()->GetValue();
    s += _T("|MasterFilterLfoTypesBox=");
    s << settingsBook->getMasterFilterLfoTypesBox()->GetSelection();
    s += _T("|MasterFilterLfoDepthSlider=");
    s << settingsBook->getMasterFilterLfoDepthSlider()->GetValue();
    s += _T("|MasterFilterLfoPeriodsPerSliceSlider=");
    s << settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
    s += _T("|MasterFilterLfoCheckbox=");
    s << settingsBook->getMasterFilterLfoCheckbox()->IsChecked();
    s += _T("|MasterFilterModulationCheckbox=");
    s << settingsBook->getMasterFilterModulationCheckbox()->IsChecked();
    s += _T("|MasterFilterResonanceCheckbox=");
    s << settingsBook->getMasterFilterResonanceCheckbox()->IsChecked();
    s += _T("|MasterFilterResonanceSlider=");
    s << settingsBook->getMasterFilterResonanceSlider()->GetValue();
    s += _T("|effectsChainGrid=");
    s += settingsBook->getEffectsChainGrid()->saveState();
    s += _T("|retriggerCountSlider=");
    s << settingsBook->getRetriggerCountSlider()->GetValue();
    s += _T("|delayPhasingDistanceOffsetSlider=");
    s << settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue();
    s += _T("|delayPhasingDistanceRangeSlider=");
    s << settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue();
    s += _T("|delayPhasingGainSlider=");
    s << settingsBook->getDelayPhasingGainSlider()->GetValue();
    s += _T("|delayPhasingLfoTypesBox=");
    s << settingsBook->getDelayPhasingLfoTypesBox()->GetSelection();
    s += _T("|delayPhasingLfoDepthSlider=");
    s << settingsBook->getDelayPhasingLfoDepthSlider()->GetValue();
    s += _T("|delayPhasingLfoPeriodsPerSliceSlider=");
    s << settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue();

    return s;
}

void smasherFrame::swapMediaCtrls ()
{
    alternativeCtrlIsCurrentCtrl = !alternativeCtrlIsCurrentCtrl;
}

wxMediaCtrl *smasherFrame::getAlternativeMediaCtrl()
{
    if ( alternativeCtrlIsCurrentCtrl )
    {
        return mediaCtrl;
    }
    return mediaCtrlAlt;
}

wxMediaCtrl *smasherFrame::getCurrentMediaCtrl()
{
    if ( alternativeCtrlIsCurrentCtrl )
    {
        return mediaCtrlAlt;
    }
    return mediaCtrl;

}

MediaTimer *smasherFrame::getCurrentMediaTimer()
{
    return ( alternativeCtrlIsCurrentCtrl ) ? mediaTimerAlt : mediaTimer;
}

void smasherFrame::startLoopTimer()
{
    if ( loopState )
        loopTimer->Start ( getCurrentMediaCtrl()->Length() - loopLatency, true );
}

void smasherFrame::updatePlotArea ()
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !pathValid )
    {
        std::cout << "updatePlotArea - !pathValid" << std::endl;
        return;
    }

    if ( w->getState() != WAV16_HAS_DATA_OUT )
    {
        std::cout << "updatePlotArea - w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
        return;
    }

    if ( !lPlot || !rPlot )
    {
        std::cout << "updatePlotArea - !lPlot || !rPlot" << std::endl;
        return;
    }

    manager->GetPane ( rPlot ).Show ( ( w->getChannels() == 2 ) );
    manager->Update();

    std::vector<double> *data = w->getDataOutPtr();

    size_t dataSize = data->size();
    size_t channelSize = dataSize / w->getChannels();
    double numberCols;
    numberCols = (double) ( mapGrid->GetNumberCols() );
    int plotPixelNo;
    plotPixelNo = (int) ( 16.0/9.0 * 16.0 * numberCols );

    if ( !plotPixelNo )
    {
        std::cout << "updatePlotArea - !plotPixelNo" << std::endl;
        return;
    }

    size_t window = channelSize / plotPixelNo;

    if ( ( dataSize < 1 ) || !window )
    {
        std::cout << "updatePlotArea -  ( dataSize < 1 ) || !window " << std::endl;
        return;
    }

    size_t i, j, channels;
    double lCurrentSample, rCurrentSample;
    double maxLCurrentSample, maxRCurrentSample;
    maxLCurrentSample = maxRCurrentSample = 0.0;

    lPlotData.clear();

    channels = w->getChannels();
    for ( i = 0, j = 0 ; i < dataSize - 1; i += channels, j++ )
    {
        lCurrentSample = fabs ( data->at ( i ) );

        if ( lCurrentSample > DOUBLE_SHRT_MAX )
            lCurrentSample = 1.0;
        else
            lCurrentSample /= DOUBLE_SHRT_MAX;
        maxLCurrentSample = ( lCurrentSample > maxLCurrentSample ) ? lCurrentSample : maxLCurrentSample;

        if ( j == window )
        {
            lPlotData.push_back ( maxLCurrentSample );
            maxLCurrentSample = 0.0;
            j = 0;
        }
    }

    lPlot->set ( &lPlotData );

    if ( channels == 1 )
    {
        if ( lPlotData.empty() )
            std::cout << "updatePlotArea: lPlotData.empty()" << std::endl;

        std::cout << "updatePlotArea: mono sample" << std::endl;
        return;
    }

    rPlotData.clear();
    for ( i = 1, j = 0 ; i < dataSize; i += channels, j++ )
    {
        rCurrentSample = fabs ( data->at ( i ) );

        if ( rCurrentSample > DOUBLE_SHRT_MAX )
            rCurrentSample = 1.0;
        else
            rCurrentSample /= DOUBLE_SHRT_MAX;
        maxRCurrentSample = ( rCurrentSample > maxRCurrentSample ) ? rCurrentSample : maxRCurrentSample;

        if ( j == window )
        {
            rPlotData.push_back ( maxRCurrentSample );
            maxRCurrentSample = 0.0;
            j = 0;
        }
    }
    rPlot->set ( &rPlotData );

    if ( rPlotData.empty() )
    {
        std::cout << "updatePlotArea: lPlotData.empty() || rPlotData.empty()" << std::endl;
        return;
    }

}

void smasherFrame::notifyPlaybackTime()
{
    if ( closeDown )
        return;

    wxLongLong llTell = getCurrentMediaCtrl()->Tell();
    int nMinutes = (int) (llTell / 60000).GetValue();
    int nSeconds = (int) ((llTell % 60000)/1000).GetValue();

    wxLongLong llLength = getCurrentMediaCtrl()->Length();
    int nMinutesTotal = (int) (llLength / 60000).GetValue();
    int nSecondsTotal = (int) ((llLength % 60000)/1000).GetValue();

    int colNo = mapGrid->GetNumberCols();
    int gridColumn = ( colNo * llTell.GetValue() ) /llLength.GetValue();

    if ( llTell.GetValue() != 0 &&
            gridColumn != gridColumnMemory &&
            gridColumn < colNo )
    {
        mapGrid->highlightCell ( gridHighlightVector.at ( gridColumn ), gridColumn );
        gridColumnMemory = gridColumn;
    }

    if ( !nMinutesTotal && !nSecondsTotal )
    {
        SetStatusText ( wxEmptyString, STATUS_TIMER );
        return;
    }
    wxString sPosition, oldPosition;
    sPosition.Printf( _T(" %i:%02i / %i:%02i"), nMinutes, nSeconds, nMinutesTotal, nSecondsTotal );
    oldPosition = GetStatusBar()->GetStatusText ( STATUS_TIMER );

    if ( oldPosition == sPosition )
        return;

    SetStatusText ( sPosition, STATUS_TIMER );
}


void smasherFrame::updateTitle ( const wxString& s )
{
    wxString name, extension, extensionSeparator;
    wxFileName::SplitPath ( s, NULL, NULL, &name, &extension );
    extensionSeparator = ( extension.empty() ) ? wxEmptyString : _T(".");
    name.Replace ( _T("_"), _T(" ") );
    SetTitle (
        name +
        extensionSeparator +
        extension +
        _(" - smasher" ) );
}

void smasherFrame::setLoopLatency ( int i )
{
    loopLatency = i;
}

void smasherFrame::OnTimer ( wxTimerEvent& e )
{
    DoIdle();
}

wxAuiManager *smasherFrame::getManager()
{
    return manager;
}
